XDconfig
code_name='Athena.c'
config_name='config.c'
widget 'boxWidgetClass' {
	include_filename='Xaw/Box.h'
	can_create=TRUE
	largeicon='box'
	largeiconheader='box.bm'
}
widget 'commandWidgetClass' {
	include_filename='Xaw/Command.h'
	can_create=TRUE
	largeicon='command'
	largeiconheader='command.bm'
}
widget 'formWidgetClass' {
	include_filename='Xaw/Form.h'
	realise='sizedCreate'
	can_create=TRUE
	largeicon='form'
	largeiconheader='form.bm'
}
widget 'labelWidgetClass' {
	include_filename='Xaw/Label.h'
	can_create=TRUE
	largeicon='label'
	largeiconheader='label.bm'
}
widget 'listWidgetClass' {
	include_filename='Xaw/List.h'
	can_create=TRUE
	largeicon='list'
	largeiconheader='list.bm'
}
widget 'panedWidgetClass' {
	include_filename='Xaw/Paned.h'
	realise='sizedCreate'
	can_create=TRUE
	largeicon='paned'
	largeiconheader='paned.bm'
}
widget 'scrollbarWidgetClass' {
	include_filename='Xaw/Scrollbar.h'
	can_create=TRUE
	largeicon='scrollbar'
	largeiconheader='scrollbar.bm'
}
widget 'stripChartWidgetClass' {
	include_filename='Xaw/StripChart.h'
	can_create=TRUE
	largeicon='strip'
	largeiconheader='strip.bm'
}
widget 'topLevelShellWidgetClass' {
	include_filename='X11/Shell.h'
	realise='shellCreate'
	can_create=TRUE
	largeicon='shell'
	largeiconheader='shell.bm'
}
enumeration 'chain' {
	typename='XtREdgeType'
	enumentry '(Rubber)'{
		code_symbol='XtRubber'
		resfile_symbol='rubber'
	}
	enumentry 'Left'{
		code_symbol='XtChainLeft'
		resfile_symbol='chainleft'
	}
	enumentry 'Right'{
		code_symbol='XtChainRight'
		resfile_symbol='chainright'
	}
	enumentry 'Rubber'{
		code_symbol='XtRubber'
		resfile_symbol='rubber'
	}
	enumentry 'Top'{
		code_symbol='XtChainTop'
		resfile_symbol='chaintop'
	}
	enumentry 'Bottom'{
		code_symbol='XtChainBottom'
		resfile_symbol='chainbottom'
	}
}
enumeration 'justify' {
	typename='XtRJustify'
	enumentry '(Center)'{
		code_symbol='XtJustifyCenter'
		resfile_symbol='center'
	}
	enumentry 'Center'{
		code_symbol='XtJustifyCenter'
		resfile_symbol='center'
	}
	enumentry 'Left'{
		code_symbol='XtJustifyLeft'
		resfile_symbol='left'
	}
	enumentry 'Right'{
		code_symbol='XtJustifyRight'
		resfile_symbol='right'
	}
}
enumeration 'orientation' {
	typename='XtROrientation'
	enumentry '(vertical)'{
		code_symbol='XtorientVertical'
		resfile_symbol='vertical'
	}
	enumentry 'horizontal'{
		code_symbol='XtorientHorizontal'
		resfile_symbol='horizontal'
	}
	enumentry 'vertical'{
		code_symbol='XtorientVertical'
		resfile_symbol='vertical'
	}
}
enumeration 'resizemode' {
	typename='XtRResizeMode'
	enumentry '(Never)'{
		code_symbol='XawtextResizeNever'
		resfile_symbol='never'
	}
	enumentry 'Width'{
		code_symbol='XawtextResizeWidth'
		resfile_symbol='width'
	}
	enumentry 'Height'{
		code_symbol='XawtextResizeHeight'
		resfile_symbol='height'
	}
	enumentry 'Both'{
		code_symbol='XawtextResizeBoth'
		resfile_symbol='both'
	}
	enumentry 'Never'{
		code_symbol='XawtextResizeNever'
		resfile_symbol='never'
	}
}
enumeration 'scrollmode' {
	typename='XtRScrollMode'
	enumentry '(Never)'{
		code_symbol='XawtextScrollNever'
		resfile_symbol='never'
	}
	enumentry 'When needed'{
		code_symbol='XawtextScrollWhenNeeded'
		resfile_symbol='whenneeded'
	}
	enumentry 'Always'{
		code_symbol='XawtextScrollAlways'
		resfile_symbol='always'
	}
	enumentry 'Never'{
		code_symbol='XawtextScrollNever'
		resfile_symbol='never'
	}
}
enumeration 'shape' {
	typename='XtRShapeStyle'
	enumentry '(Rectangle)'{
		code_symbol='XmuShapeRectangle'
		resfile_symbol='Rectangle'
	}
	enumentry 'Ellipse'{
		code_symbol='XmuShapeEllipse'
		resfile_symbol='Ellipse'
	}
	enumentry 'Oval'{
		code_symbol='XmuShapeOval'
		resfile_symbol='Oval'
	}
	enumentry 'Rect'{
		code_symbol='XmuShapeRectangle'
		resfile_symbol='Rectangle'
	}
	enumentry 'Rounded'{
		code_symbol='XmuShapeRoundedRectangle'
		resfile_symbol='RoundedRectangle'
	}
}
enumeration 'wrap' {
	typename='XtRWrapMode'
	enumentry '(Never)'{
		code_symbol='XawtextWrapNever'
		resfile_symbol='never'
	}
	enumentry 'Word'{
		code_symbol='XawtextWrapWord'
		resfile_symbol='word'
	}
	enumentry 'Line'{
		code_symbol='XawtextWrapLine'
		resfile_symbol='line'
	}
	enumentry 'Never'{
		code_symbol='XawtextWrapNever'
		resfile_symbol='never'
	}
}
cheader 'Xaw/FormP.h'
cheader 'Xaw/Text.h'
cheader 'Xaw/TextP.h'
cheader 'Xmu/Converters.h'
popup 'xd_colour_dialog_create' {
	dialog_init='xd_colour_dialog_initialise'
}
popup 'xd_font_dialog_create' {
	dialog_init='xd_font_dialog_initialise'
}
popup 'xd_fsb_dialog_create' {
	dialog_init='xd_fsb_dialog_initialise'
}
popup 'xd_pixmap_dialog_create' {
	dialog_init='xd_pixmap_dialog_initialise'
}
popup 'xd_string_dialog_create' {
	dialog_init='xd_string_dialog_initialise'
}
page 'display'
page 'margins'
page 'settings'
page 'callbacks'
page 'misc'
family 'Athena' {
	widget='commandWidgetClass'
	widget='formWidgetClass'
	widget='labelWidgetClass'
	widget='listWidgetClass'
	widget='panedWidgetClass'
	widget='scrollbarWidgetClass'
	widget='stripChartWidgetClass'
	widget='topLevelShellWidgetClass'
	widget='boxWidgetClass'
	enumeration='chain'
	enumeration='justify'
	enumeration='shape'
	cheader='Xaw/FormP.h'
	cheader='Xmu/Converters.h'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
}
family 'Composites' {
	widget='topLevelShellWidgetClass'
	widget='boxWidgetClass'
	widget='formWidgetClass'
	widget='panedWidgetClass'
	enumeration='chain'
	enumeration='orientation'
	cheader='Xaw/FormP.h'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
}
family 'Primitives' {
	widget='labelWidgetClass'
	widget='commandWidgetClass'
	widget='scrollbarWidgetClass'
	widget='listWidgetClass'
	widget='stripChartWidgetClass'
	enumeration='justify'
	enumeration='resizemode'
	enumeration='scrollmode'
	enumeration='shape'
	enumeration='wrap'
	cheader='Xmu/Converters.h'
	cheader='Xaw/TextP.h'
	cheader='Xaw/Text.h'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
}
