XDconfig
code_name='xrtcode.c'
config_name='xrtconfig.c'
widget 'xmXrtComboBoxWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtcombobox'
	smallicon='xrtcombobox20'
	largeiconheader='builtin_bitmaps/xrtcombobox.bm'
	smalliconheader='builtin_bitmaps/xrtcombobox20.bm'
	resource_definitions='XmNxrtComboArrow', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtComboArrowClass', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtComboField', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtComboFieldClass', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtComboFieldType', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtCurrencyFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtcurrencyfield'
	smallicon='xrtcurrencyfield20'
	largeiconheader='builtin_bitmaps/xrtcurrencyfield.bm'
	smalliconheader='builtin_bitmaps/xrtcurrencyfield20.bm'
}
widget 'xmXrtDateFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtdatefield'
	smallicon='xrtdatefield20'
	largeiconheader='builtin_bitmaps/xrtdatefield.bm'
	smalliconheader='builtin_bitmaps/xrtdatefield20.bm'
	resource_definitions='XmNxrtFldCounterIncrement', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDefaultValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayFormatString', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldEnterFormatList', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInternalValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInternalValueLong', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMax', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMin', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPickList', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	largeicon='xrtfield'
	smallicon='xrtfield20'
	largeiconheader='builtin_bitmaps/xrtfield.bm'
	smalliconheader='builtin_bitmaps/xrtfield20.bm'
	resource_definitions='XmNxrtFldAllowNull', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldCase', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldCompleteCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldConvertCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDefaultBackground', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDefaultForeground', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayFormat', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayHorizScrollBar', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayVertScrollBar', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldEditFormat', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldEnterCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldErrorBackground', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldErrorCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldErrorForeground', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldErrorString', 'xd_string_dialog_create', 'display', TRUE, XDC_DONT_FREE, XDC_FREE_DEFAULT,
'XmNxrtFldExitCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInvalidChars', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldIsDefault', , 'readonly', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldIsModified', , 'readonly', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldIsValid', , 'readonly', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldLastError', , 'readonly', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMask', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMaskChars', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMatchMask', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMatchPickList', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMaxLineLength', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMaxLines', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMenuCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldOverstrike', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPickListIndex', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPromptString', 'xd_string_dialog_create', 'display', TRUE, XDC_DONT_FREE, XDC_FREE_DEFAULT,
'XmNxrtFldRange', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldSpinCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldValidChars', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldValidateCallback', , 'callbacks', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldVisibleItemCount', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtFloatFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtfloatfield'
	smallicon='xrtfloatfield20'
	largeiconheader='builtin_bitmaps/xrtfloatfield.bm'
	smalliconheader='builtin_bitmaps/xrtfloatfield20.bm'
	resource_definitions='XmNxrtFldCounterIncrement', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDecimalPlaces', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDefaultValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayFormatString', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInternalValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldLeadingZero', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMax', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMin', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldNegativeFormat', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPickList', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtIntFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtintfield'
	smallicon='xrtintfield20'
	largeiconheader='builtin_bitmaps/xrtintfield.bm'
	smalliconheader='builtin_bitmaps/xrtintfield20.bm'
	resource_definitions='XmNxrtFldCounterIncrement', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDefaultValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldDisplayFormatString', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInternalValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMax', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMin', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldNegativeFormat', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPickList', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtSpinBoxWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtspinbox'
	smallicon='xrtspinbox20'
	largeiconheader='builtin_bitmaps/xrtspinbox.bm'
	smalliconheader='builtin_bitmaps/xrtspinbox20.bm'
	resource_definitions='XmNxrtSpinArrowLayout', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinArrowOrientation', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinDecrArrow', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinDecrArrowClass', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinField', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinFieldClass', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinFieldName', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinFieldType', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinIncrArrow', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinIncrArrowClass', , 'settings', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtSpinType', , 'settings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xmXrtStringFieldWidgetClass' {
	include_filename='Xm/XrtField.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtstringfield'
	smallicon='xrtstringfield20'
	largeiconheader='builtin_bitmaps/xrtstringfield.bm'
	smalliconheader='builtin_bitmaps/xrtstringfield20.bm'
	resource_definitions='XmNxrtFldDefaultValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldInternalValue', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMax', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldMin', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtFldPickList', , 'values', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xtXrt3dWidgetClass' {
	include_filename='Xm/Xrt3d.h'
	can_add_child='Xrt3d_can_add_child'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrt3d'
	smallicon='xrt3d20'
	largeiconheader='builtin_bitmaps/xrt3d.bm'
	smalliconheader='builtin_bitmaps/xrt3d20.bm'
	resource_definitions='XtNxrt3dAxisStrokeFont', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dAxisStrokeSize', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dAxisTitleStrokeFont', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dAxisTitleStrokeSize', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dContourStyles', , 'Contours', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDataAreaBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDebug', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDistnMethod', , 'Contours', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDistnTable', , 'Contours', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDoubleBuffer', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDrawContours', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDrawHiddenLines', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDrawMesh', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDrawShaded', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dDrawZones', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterAdjust', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterBackgroundColor', 'xd_colour_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterBorder', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterBorderWidth', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterFont', 'xd_font_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterForegroundColor', 'xd_colour_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterHeight', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterStrings', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterWidth', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterX', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterXUseDefault', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterY', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dFooterYUseDefault', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dForegroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphBorder', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphBorderWidth', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphForegroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphHeight', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphHeightUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphWidth', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphWidthUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphX', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphXUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphY', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dGraphYUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderAdjust', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderBackgroundColor', 'xd_colour_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderBorder', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderBorderWidth', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderFont', 'xd_font_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderForegroundColor', 'xd_colour_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderHeight', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderStrings', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderWidth', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderX', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderXUseDefault', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderY', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dHeaderYUseDefault', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendAnchor', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendBackgroundColor', 'xd_colour_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendBorder', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendBorderWidth', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendFont', 'xd_font_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendForegroundColor', 'xd_colour_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendHeight', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendLabelFunc', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendOrientation', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendShow', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendStrings', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendStyle', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendWidth', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendX', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendXUseDefault', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendY', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dLegendYUseDefault', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dMeshBottomColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dMeshTopColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dNumDistnLevels', , 'Contours', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dPerspectiveDepth', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dProjectZMax', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dProjectZMin', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dRepaint', , 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dSolidSurface', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dSurfaceBottomColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dSurfaceData', 'xd_fsb_dialog_create', 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dSurfaceTopColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dTextList', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dType', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dViewNormalized', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dViewScale', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dViewXTranslate', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dViewYTranslate', , 'Axis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXAnnoMethod', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXAxisShow', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXAxisTitle', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXBarFormat', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXBarSpacing', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXDataLabels', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXGridLines', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMax', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMaxUseDefault', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMeshFilter', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMeshShow', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMin', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXMinUseDefault', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXRotation', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXScale', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXValueLabels', , 'XAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dXYColors', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYAnnoMethod', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYAxisShow', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYAxisTitle', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYBarFormat', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYBarSpacing', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYDataLabels', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYGridLines', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMax', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMaxUseDefault', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMeshFilter', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMeshShow', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMin', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYMinUseDefault', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYRotation', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYScale', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dYValueLabels', , 'YAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZAnnoMethod', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZAxisShow', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZAxisTitle', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZGridLines', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZMax', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZMaxUseDefault', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZMin', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZMinUseDefault', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZOrigin', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZRotation', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZScale', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZValueLabels', , 'ZAxis', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZoneData', 'xd_fsb_dialog_create', 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrt3dZoneMethod', , 'DataSettings', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xtXrtGraphWidgetClass' {
	include_filename='Xm/XrtGraph.h'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtgraph'
	smallicon='xrtgraph20'
	largeiconheader='builtin_bitmaps/xrtgraph.bm'
	smalliconheader='builtin_bitmaps/xrtgraph20.bm'
	resource_definitions='XtNxrtAxisBoundingBox', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtAxisFont', 'xd_font_dialog_create', 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtBarClusterOverlap', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtBarClusterWidth', , 'Bar', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtData', 'xd_fsb_dialog_create', 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtData2', 'xd_fsb_dialog_create', 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDataAreaBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDataStyles', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDataStyles2', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDataStyles2UseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDataStylesUseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDebug', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtDoubleBuffer', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterAdjust', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterBackgroundColor', 'xd_colour_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterBorder', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterBorderWidth', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterFont', 'xd_font_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterForegroundColor', 'xd_colour_dialog_create', 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterHeight', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterStrings', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterWidth', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterX', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterXUseDefault', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterY', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFooterYUseDefault', , 'Footer', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtForegroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtFrontDataset', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphBackgroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphBorder', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphBorderWidth', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphDepth', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphForegroundColor', 'xd_colour_dialog_create', 'display', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphHeight', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphHeightUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphInclination', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginBottom', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginBottomUseDefault', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginLeft', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginLeftUseDefault', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginRight', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginRightUseDefault', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginTop', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphMarginTopUseDefault', , 'margins', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphRotation', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphWidth', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphWidthUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphX', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphXUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphY', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtGraphYUseDefault', , 'Graph', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderAdjust', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderBackgroundColor', 'xd_colour_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderBorder', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderBorderWidth', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderFont', 'xd_font_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderForegroundColor', 'xd_colour_dialog_create', 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderHeight', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderStrings', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderWidth', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderX', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderXUseDefault', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderY', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtHeaderYUseDefault', , 'Header', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtInvertOrientation', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendAnchor', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendBackgroundColor', 'xd_colour_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendBorder', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendBorderWidth', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendFont', 'xd_font_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendForegroundColor', 'xd_colour_dialog_create', 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendHeight', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendOrientation', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendShow', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendWidth', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendX', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendXUseDefault', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendY', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtLegendYUseDefault', , 'Legend', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtMarkerDataStyle', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtMarkerDataStyleUseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtMarkerDataset', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtOtherDataStyle', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtOtherDataStyleUseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtOtherLabel', , 'Pie', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPieMinSlices', , 'Pie', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPieOrder', , 'Pie', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPieThresholdMethod', , 'Pie', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPieThresholdValue', , 'Pie', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPointLabels', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtPointLabels2', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtRepaint', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtSetLabels', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtSetLabels2', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtTimeBase', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtTimeFormat', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtTimeFormatUseDefault', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtTimeUnit', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtTransposeData', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtType', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtType2', , 'DrawOpts', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAnnoPlacement', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAnnotationMethod', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAnnotationRotation', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisLogarithmic', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisMax', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisMaxUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisMin', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisMinUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisReversed', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXAxisShow', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXGrid', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXGridDataStyle', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXGridDataStyleUseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXGridUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXLabels', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMarker', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMarkerPoint', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMarkerSet', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMarkerShow', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMax', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMaxUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMin', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXMinUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXNum', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXNumMethod', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXNumUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXOrigin', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXOriginPlacement', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXOriginUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXPrecision', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXPrecisionUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXTick', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXTickUseDefault', , 'X_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXTitle', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtXTitleRotation', , 'X_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AnnotationMethod', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AnnotationRotation', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisLogarithmic', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisMax', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisMaxUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisMin', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisMinUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisReversed', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2AxisShow', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Labels', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Max', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2MaxUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Min', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2MinUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Num', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2NumMethod', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2NumUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Precision', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2PrecisionUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Tick', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2TickUseDefault', , 'Y2_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2Title', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtY2TitleRotation', , 'Y2_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAnnoPlacement', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAnnotationMethod', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAnnotationRotation', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisConst', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisLogarithmic', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisMax', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisMaxUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisMin', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisMinUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisMult', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisReversed', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYAxisShow', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYGrid', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYGridDataStyle', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYGridDataStyleUseDefault', , 'DataStyles', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYGridUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYLabels', , 'Labels', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMarker', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMarkerShow', , 'Marker', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMax', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMaxUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMin', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYMinUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYNum', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYNumMethod', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYNumUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYOrigin', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYOriginPlacement', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYOriginUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYPrecision', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYPrecisionUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYTick', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYTickUseDefault', , 'Y_Axis1', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYTitle', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XtNxrtYTitleRotation', , 'Y_Axis2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xtXrtLabelWidgetClass' {
	include_filename='Xm/XrtLabel.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrtlabel'
	smallicon='xrtlabel20'
	largeiconheader='builtin_bitmaps/xrtlabel.bm'
	smalliconheader='builtin_bitmaps/xrtlabel20.bm'
	resource_definitions='XmNalignment', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNfontList', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNlabelPixmap', 'xd_pixmap_dialog_create', 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNlabelString', 'xd_string_dialog_create', 'Label', TRUE, XDC_DONT_FREE, XDC_FREE_DEFAULT,
'XmNlabelType', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNmarginHeight', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNmarginWidth', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNrecomputeSize', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNshadowThickness', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNstringDirection', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtLblBackgroundString', 'xd_colour_dialog_create', 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtLblBorderType', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtLblForegroundString', 'xd_colour_dialog_create', 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtLblRotation', , 'Label', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
widget 'xtXrtTableWidgetClass' {
	include_filename='Xm/XrtTable.h'
	defined_name='XRT_Xm_defined_name'
	can_create=TRUE
	generate_initialise=TRUE
	largeicon='xrttable'
	smallicon='xrttable20'
	largeiconheader='builtin_bitmaps/xrttable.bm'
	smalliconheader='builtin_bitmaps/xrttable20.bm'
	resource_definitions='XmNxrtTblAlignmentContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblAlignmentSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblAllowCellResize', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblAllowResize', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblArgListContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblArgListSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBackgroundContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBackgroundPixelContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBackgroundSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBackingStore', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBorderSidesContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBorderSidesSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBorderTypeContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBorderTypeSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBottomOffset', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblBottomShadowContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCaseContext', , 'Cell-only Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCaseSeries', , 'Cell-only Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCellValueContext', 'xd_string_dialog_create', 'Cell-only Context', TRUE, XDC_DONT_FREE, XDC_FREE_DEFAULT,
'XmNxrtTblCellValueFunc', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCellValues', 'xd_fsb_dialog_create', 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCharHeightContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCharHeightSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCharWidthContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCharWidthSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblClipChildren', , 'Child Widget', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblClipChildrenPersistent', , 'Child Widget', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblClipPixmapContext', 'xd_pixmap_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblClipPixmapSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblColumnLabelOffset', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblColumnLabelPlacement', , 'Label-only ', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblColumnLabels', , 'Label-only ', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCursorCorner', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCursorHorizontal', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCursorNontraversable', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCursorTraversable', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblCursorVertical', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDataTypeContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDataTypeList', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDataTypeSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDebug', , 'Other', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDisplayClipArrows', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDisplayHorizScrollBar', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDisplayVertScrollBar', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblDoubleBuffer', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblEditableContext', , 'Cell-only Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblEditableSeries', , 'Cell-only Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblExportDelimiter', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblExportTargets', , 'Other', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFieldArgListContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFieldArgListSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFontListContext', 'xd_font_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFontListSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblForegroundContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblForegroundPixelContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblForegroundSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrameBorderType', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrameShadowThickness', , 'Table wide', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrozenColumnPlacement', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrozenColumns', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrozenRowPlacement', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblFrozenRows', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblHorizScrollBarLeftAttachment', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblHorizScrollBarPlacement', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblHorizScrollBarPosition', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblHorizScrollBarRightAttachment', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblHorizontalScrollBar', , 'Child Widget', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblImportDelimiter', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblImportTargets', , 'Other', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblJumpScroll', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblLabelContext', 'xd_string_dialog_create', 'Label-only ', TRUE, XDC_DONT_FREE, XDC_FREE_DEFAULT,
'XmNxrtTblLabelCreateFunc', , 'Label-only ', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblLeftColumn', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblLeftOffset', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblLocation', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMarginHeight', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMarginWidth', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMaxLengthContext', , 'Cell-only Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMaxLengthSeries', , 'Cell-only Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMinCellVisibility', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMinFlexibleHeight', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMinFlexibleWidth', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMode', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMultilineContext', , 'Cell-only Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblMultilineSeries', , 'Cell-only Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblNumColumns', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblNumRows', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblOverflowContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblOverflowSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPSFontListContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPSFontListSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPSFontMapList', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixelHeightContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixelHeightSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixelWidthContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixelWidthSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapContext', 'xd_pixmap_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapLayoutContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapLayoutSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapShadowContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblPixmapShadowSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRangeContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRepaint', , 'Other', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRepeatBackgroundColors', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRepeatForegroundColors', , 'Table wide 2', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRightOffset', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRowLabelOffset', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRowLabelPlacement', , 'Label-only ', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblRowLabels', , 'Label-only ', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSelectedBackground', 'xd_colour_dialog_create', 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSelectedCellList', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSelectedForeground', 'xd_colour_dialog_create', 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSelectionPolicy', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSetTextCursorPos', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblShadowThickness', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSpace', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblSpanList', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblText', , 'Child Widget', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTextInitSelect', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTopOffset', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTopRow', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTopShadowContext', 'xd_colour_dialog_create', 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTrackCursor', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTraversableContext', , 'Cell-only Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblTraversableSeries', , 'Cell-only Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblUserDataContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblUserDataSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblValidatePolicy', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVertScrollBarBottomAttachment', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVertScrollBarPlacement', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVertScrollBarPosition', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVertScrollBarTopAttachment', , 'Scroll Bars', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVerticalScrollBar', , 'Child Widget', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVisibleColumns', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblVisibleRows', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetClassList', , 'Table wide 3', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetLocation', , 'Constraint', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetShadowContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWidgetShadowSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWordWrapContext', , 'Cell/Label Context', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblWordWrapSeries', , 'Cell/Label Series', TRUE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblXmStringGetMode', , 'Table wide 3', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT,
'XmNxrtTblXmStringSetMode', , 'Table wide 3', FALSE, XDC_FREE_DEFAULT, XDC_FREE_DEFAULT;
}
enumeration 'Alignment' {
	typename='XmRAlignment'
	enumentry '(Center)'{
		code_symbol='XmALIGNMENT_CENTER'
		resfile_symbol='ALIGNMENT_CENTER'
	}
	enumentry 'Beginning'{
		code_symbol='XmALIGNMENT_BEGINNING'
		resfile_symbol='ALIGNMENT_BEGINNING'
	}
	enumentry 'Center'{
		code_symbol='XmALIGNMENT_CENTER'
		resfile_symbol='ALIGNMENT_CENTER'
	}
	enumentry 'End'{
		code_symbol='XmALIGNMENT_END'
		resfile_symbol='ALIGNMENT_END'
	}
}
enumeration 'LabelType' {
	typename='XmRLabelType'
	enumentry '(String)'{
		code_symbol='XmSTRING'
		resfile_symbol='STRING'
	}
	enumentry 'Pixmap'{
		code_symbol='XmPIXMAP'
		resfile_symbol='PIXMAP'
	}
	enumentry 'String'{
		code_symbol='XmSTRING'
		resfile_symbol='STRING'
	}
}
enumeration 'Orientation' {
	typename='XmROrientation'
	enumentry '(Horizontal)'{
		code_symbol='XmHORIZONTAL'
		resfile_symbol='HORIZONTAL'
	}
	enumentry 'Horizontal'{
		code_symbol='XmHORIZONTAL'
		resfile_symbol='HORIZONTAL'
	}
	enumentry 'Vertical'{
		code_symbol='XmVERTICAL'
		resfile_symbol='VERTICAL'
	}
}
enumeration 'StringDirection' {
	typename='XmRStringDirection'
	enumentry '(Default)'{
		code_symbol='XmSTRING_DIRECTION_DEFAULT'
		resfile_symbol='STRING_DIRECTION_DEFAULT'
	}
	enumentry 'Left To Right'{
		code_symbol='XmSTRING_DIRECTION_L_TO_R'
		resfile_symbol='STRING_DIRECTION_L_TO_R'
	}
	enumentry 'Right To Left'{
		code_symbol='XmSTRING_DIRECTION_R_TO_L'
		resfile_symbol='STRING_DIRECTION_R_TO_L'
	}
}
enumeration 'Xrt3dAdjust' {
	typename='XtRXrt3dAdjust'
	enumentry '(Center)'{
		code_symbol='XRT3D_ADJUST_CENTER'
		resfile_symbol='AdjustCenter'
	}
	enumentry 'Left'{
		code_symbol='XRT3D_ADJUST_LEFT'
		resfile_symbol='AdjustLeft'
	}
	enumentry 'Center'{
		code_symbol='XRT3D_ADJUST_CENTER'
		resfile_symbol='AdjustCenter'
	}
	enumentry 'Right'{
		code_symbol='XRT3D_ADJUST_RIGHT'
		resfile_symbol='AdjustRight'
	}
}
enumeration 'Xrt3dAlign' {
	typename='XtRXrt3dAlign'
	enumentry '(Vertical)'{
		code_symbol='XRT3D_ALIGN_VERTICAL'
		resfile_symbol='AlignVertical'
	}
	enumentry 'Vertical'{
		code_symbol='XRT3D_ALIGN_VERTICAL'
		resfile_symbol='AlignVertical'
	}
	enumentry 'Horizontal'{
		code_symbol='XRT3D_ALIGN_HORIZONTAL'
		resfile_symbol='AlignHorizontal'
	}
}
enumeration 'Xrt3dAnchor' {
	typename='XtRXrt3dAnchor'
	enumentry '(East)'{
		code_symbol='XRT3D_ANCHOR_EAST'
		resfile_symbol='AnchorEast'
	}
	enumentry 'North'{
		code_symbol='XRT3D_ANCHOR_NORTH'
		resfile_symbol='AnchorNorth'
	}
	enumentry 'South'{
		code_symbol='XRT3D_ANCHOR_SOUTH'
		resfile_symbol='AnchorSouth'
	}
	enumentry 'East'{
		code_symbol='XRT3D_ANCHOR_EAST'
		resfile_symbol='AnchorEast'
	}
	enumentry 'West'{
		code_symbol='XRT3D_ANCHOR_WEST'
		resfile_symbol='AnchorWest'
	}
	enumentry 'Northwest'{
		code_symbol='XRT3D_ANCHOR_NORTHWEST'
		resfile_symbol='AnchorNorthwest'
	}
	enumentry 'Northeast'{
		code_symbol='XRT3D_ANCHOR_NORTHEAST'
		resfile_symbol='AnchorNortheast'
	}
	enumentry 'Southwest'{
		code_symbol='XRT3D_ANCHOR_SOUTHWEST'
		resfile_symbol='AnchorSouthwest'
	}
	enumentry 'Southeast'{
		code_symbol='XRT3D_ANCHOR_SOUTHEAST'
		resfile_symbol='AnchorSoutheast'
	}
}
enumeration 'Xrt3dAnnoMethod' {
	typename='XtRXrt3dAnnoMethod'
	enumentry '(Values)'{
		code_symbol='XRT3D_ANNO_VALUES'
		resfile_symbol='AnnoValues'
	}
	enumentry 'Values'{
		code_symbol='XRT3D_ANNO_VALUES'
		resfile_symbol='AnnoValues'
	}
	enumentry 'Data Labels'{
		code_symbol='XRT3D_ANNO_DATA_LABELS'
		resfile_symbol='AnnoDataLabels'
	}
	enumentry 'Value Labels'{
		code_symbol='XRT3D_ANNO_VALUE_LABELS'
		resfile_symbol='AnnoValueLabels'
	}
}
enumeration 'Xrt3dBarFormat' {
	typename='XtRXrt3dBarFormat'
	enumentry '(Fixed)'{
		code_symbol='XRT3D_BAR_FIXED'
		resfile_symbol='BarFixed'
	}
	enumentry 'Fixed'{
		code_symbol='XRT3D_BAR_FIXED'
		resfile_symbol='BarFixed'
	}
	enumentry 'Histogram'{
		code_symbol='XRT3D_BAR_HISTOGRAM'
		resfile_symbol='BarHistogram'
	}
}
enumeration 'Xrt3dBorder' {
	typename='XtRXrt3dBorder'
	enumentry '(None)'{
		code_symbol='XRT3D_BORDER_NONE'
		resfile_symbol='BorderNone'
	}
	enumentry 'None'{
		code_symbol='XRT3D_BORDER_NONE'
		resfile_symbol='BorderNone'
	}
	enumentry '3D Out'{
		code_symbol='XRT3D_BORDER_3D_OUT'
		resfile_symbol='Border3dOut'
	}
	enumentry '3D In'{
		code_symbol='XRT3D_BORDER_3D_IN'
		resfile_symbol='Border3dIn'
	}
	enumentry 'Shadow'{
		code_symbol='XRT3D_BORDER_SHADOW'
		resfile_symbol='BorderShadow'
	}
	enumentry 'Plain'{
		code_symbol='XRT3D_BORDER_PLAIN'
		resfile_symbol='BorderPlain'
	}
	enumentry 'Etched In'{
		code_symbol='XRT3D_BORDER_ETCHED_IN'
		resfile_symbol='BorderEtchedIn'
	}
	enumentry 'Etched Out'{
		code_symbol='XRT3D_BORDER_ETCHED_OUT'
		resfile_symbol='BorderEtchedOut'
	}
}
enumeration 'Xrt3dDistnMethod' {
	typename='XtRXrt3dDistnMethod'
	enumentry '(Linear)'{
		code_symbol='XRT3D_DISTN_LINEAR'
		resfile_symbol='DistnLinear'
	}
	enumentry 'Linear'{
		code_symbol='XRT3D_DISTN_LINEAR'
		resfile_symbol='DistnLinear'
	}
	enumentry 'Table'{
		code_symbol='XRT3D_DISTN_TABLE'
		resfile_symbol='DistnTable'
	}
}
enumeration 'Xrt3dLegendStyle' {
	typename='XtRXrt3dLegendStyle'
	enumentry '(Continuous)'{
		code_symbol='XRT3D_LEGEND_STYLE_CONTINUOUS'
		resfile_symbol='LegendStyleContinuous'
	}
	enumentry 'Stepped'{
		code_symbol='XRT3D_LEGEND_STYLE_STEPPED'
		resfile_symbol='LegendStyleStepped'
	}
	enumentry 'Continuous'{
		code_symbol='XRT3D_LEGEND_STYLE_CONTINUOUS'
		resfile_symbol='LegendStyleContinuous'
	}
}
enumeration 'Xrt3dStrokeFont' {
	typename='XtRXrt3dStrokeFont'
	enumentry '(Roman Simplex)'{
		code_symbol='XRT3D_SF_ROMAN_SIMPLEX'
		resfile_symbol='SFRomanSimplex'
	}
	enumentry 'Cyrillic Complex'{
		code_symbol='XRT3D_SF_CYRILLIC_COMPLEX'
		resfile_symbol='SFCyrillicComplex'
	}
	enumentry 'Gothic English'{
		code_symbol='XRT3D_SF_GOTHIC_ENGLISH'
		resfile_symbol='SFGothicEnglish'
	}
	enumentry 'Gothic German'{
		code_symbol='XRT3D_SF_GOTHIC_GERMAN'
		resfile_symbol='SFGothicGerman'
	}
	enumentry 'Gothic Italian'{
		code_symbol='XRT3D_SF_GOTHIC_ITALIAN'
		resfile_symbol='SFGothicItalian'
	}
	enumentry 'Greek Complex'{
		code_symbol='XRT3D_SF_GREEK_COMPLEX'
		resfile_symbol='SFGreekComplex'
	}
	enumentry 'Greek Complex Small'{
		code_symbol='XRT3D_SF_GREEK_COMPLEX_SMALL'
		resfile_symbol='SFGreekComplexSmall'
	}
	enumentry 'Greek Simplex'{
		code_symbol='XRT3D_SF_GREEK_SIMPLEX'
		resfile_symbol='SFGreekSimplex'
	}
	enumentry 'Italic Complex'{
		code_symbol='XRT3D_SF_ITALIC_COMPLEX'
		resfile_symbol='SFItalicComplex'
	}
	enumentry 'Italic Complex Small'{
		code_symbol='XRT3D_SF_ITALIC_COMPLEX_SMALL'
		resfile_symbol='SFItalicComplexSmall'
	}
	enumentry 'Italic Triplex'{
		code_symbol='XRT3D_SF_ITALIC_TRIPLEX'
		resfile_symbol='SFItalicTriplex'
	}
	enumentry 'Roman Complex'{
		code_symbol='XRT3D_SF_ROMAN_COMPLEX'
		resfile_symbol='SFRomanComplex'
	}
	enumentry 'Roman Complex Small'{
		code_symbol='XRT3D_SF_ROMAN_COMPLEX_SMALL'
		resfile_symbol='SFRomanComplexSmall'
	}
	enumentry 'Roman Duplex'{
		code_symbol='XRT3D_SF_ROMAN_DUPLEX'
		resfile_symbol='SFRomanDuplex'
	}
	enumentry 'Roman Simplex'{
		code_symbol='XRT3D_SF_ROMAN_SIMPLEX'
		resfile_symbol='SFRomanSimplex'
	}
	enumentry 'Roman Triplex'{
		code_symbol='XRT3D_SF_ROMAN_TRIPLEX'
		resfile_symbol='SFRomanTriplex'
	}
	enumentry 'Script Complex'{
		code_symbol='XRT3D_SF_SCRIPT_COMPLEX'
		resfile_symbol='SFScriptComplex'
	}
	enumentry 'Script Simplex'{
		code_symbol='XRT3D_SF_SCRIPT_SIMPLEX'
		resfile_symbol='SFScriptSimplex'
	}
}
enumeration 'Xrt3dType' {
	typename='XtRXrt3dType'
	enumentry '(Surface)'{
		code_symbol='XRT3D_TYPE_SURFACE'
		resfile_symbol='TypeSurface'
	}
	enumentry 'Surface'{
		code_symbol='XRT3D_TYPE_SURFACE'
		resfile_symbol='TypeSurface'
	}
	enumentry 'Bar'{
		code_symbol='XRT3D_TYPE_BAR'
		resfile_symbol='TypeBar'
	}
}
enumeration 'Xrt3dZoneMethod' {
	typename='XtRXrt3dZoneMethod'
	enumentry '(Contours)'{
		code_symbol='XRT3D_ZONE_CONTOURS'
		resfile_symbol='ZoneContours'
	}
	enumentry 'Contours'{
		code_symbol='XRT3D_ZONE_CONTOURS'
		resfile_symbol='ZoneContours'
	}
	enumentry 'Cells'{
		code_symbol='XRT3D_ZONE_CELLS'
		resfile_symbol='ZoneCells'
	}
}
enumeration 'XrtAdjust' {
	typename='XtRXrtAdjust'
	enumentry '(Center)'{
		code_symbol='XRT_ADJUST_CENTER'
		resfile_symbol='AdjustCenter'
	}
	enumentry 'Left'{
		code_symbol='XRT_ADJUST_LEFT'
		resfile_symbol='AdjustLeft'
	}
	enumentry 'Right'{
		code_symbol='XRT_ADJUST_RIGHT'
		resfile_symbol='AdjustRight'
	}
	enumentry 'Center'{
		code_symbol='XRT_ADJUST_CENTER'
		resfile_symbol='AdjustCenter'
	}
}
enumeration 'XrtAlign' {
	typename='XtRXrtAlign'
	enumentry '(vertical)'{
		code_symbol='XRT_ALIGN_VERTICAL'
		resfile_symbol='AlignVertical'
	}
	enumentry 'vertical'{
		code_symbol='XRT_ALIGN_VERTICAL'
		resfile_symbol='AlignVertical'
	}
	enumentry 'horizontal'{
		code_symbol='XRT_ALIGN_HORIZONTAL'
		resfile_symbol='AlignHorizontal'
	}
}
enumeration 'XrtAnchor' {
	typename='XtRXrtAnchor'
	enumentry '(North)'{
		code_symbol='XRT_ANCHOR_NORTH'
		resfile_symbol='AnchorNorth'
	}
	enumentry 'North'{
		code_symbol='XRT_ANCHOR_NORTH'
		resfile_symbol='AnchorNorth'
	}
	enumentry 'South'{
		code_symbol='XRT_ANCHOR_SOUTH'
		resfile_symbol='AnchorSouth'
	}
	enumentry 'East'{
		code_symbol='XRT_ANCHOR_EAST'
		resfile_symbol='AnchorEast'
	}
	enumentry 'West'{
		code_symbol='XRT_ANCHOR_WEST'
		resfile_symbol='AnchorWest'
	}
	enumentry 'NorthEast'{
		code_symbol='XRT_ANCHOR_NORTHEAST'
		resfile_symbol='AnchorNorthEast'
	}
	enumentry 'NorthWest'{
		code_symbol='XRT_ANCHOR_NORTHWEST'
		resfile_symbol='AnchorNorthWest'
	}
	enumentry 'SouthEast'{
		code_symbol='XRT_ANCHOR_SOUTHEAST'
		resfile_symbol='AnchorSouthEast'
	}
	enumentry 'SouthWest'{
		code_symbol='XRT_ANCHOR_SOUTHWEST'
		resfile_symbol='AnchorSouthWest'
	}
}
enumeration 'XrtAnnoMethod' {
	typename='XtRXrtAnnotationMethod'
	enumentry '(Values)'{
		code_symbol='XRT_ANNO_VALUES'
		resfile_symbol='AnnoValues'
	}
	enumentry 'Values'{
		code_symbol='XRT_ANNO_VALUES'
		resfile_symbol='AnnoValues'
	}
	enumentry 'PointLabels'{
		code_symbol='XRT_ANNO_POINT_LABELS'
		resfile_symbol='AnnoPointLabels'
	}
	enumentry 'ValueLabels'{
		code_symbol='XRT_ANNO_VALUE_LABELS'
		resfile_symbol='AnnoValueLabels'
	}
	enumentry 'TimeLabels'{
		code_symbol='XRT_ANNO_TIME_LABELS'
		resfile_symbol='AnnoTimeLabels'
	}
}
enumeration 'XrtAnnoPlacement' {
	typename='XtRXrtAnnoPlacement'
	enumentry '(Auto)'{
		code_symbol='XRT_ANNO_AUTO'
		resfile_symbol='AnnoAuto'
	}
	enumentry 'Auto'{
		code_symbol='XRT_ANNO_AUTO'
		resfile_symbol='AnnoAuto'
	}
	enumentry 'Origin'{
		code_symbol='XRT_ANNO_ORIGIN'
		resfile_symbol='AnnoOrigin'
	}
	enumentry 'Min'{
		code_symbol='XRT_ANNO_MIN'
		resfile_symbol='AnnoMin'
	}
	enumentry 'Max'{
		code_symbol='XRT_ANNO_MAX'
		resfile_symbol='AnnoMax'
	}
}
enumeration 'XrtBorder' {
	typename='XtRXrtBorder'
	enumentry '(BorderNone)'{
		code_symbol='XRT_BORDER_NONE'
		resfile_symbol='BorderNone'
	}
	enumentry 'BorderNone'{
		code_symbol='XRT_BORDER_NONE'
		resfile_symbol='BorderNone'
	}
	enumentry 'Border3dOut'{
		code_symbol='XRT_BORDER_3D_OUT'
		resfile_symbol='Border3dOut'
	}
	enumentry 'Border3dIn'{
		code_symbol='XRT_BORDER_3D_IN'
		resfile_symbol='Border3dIn'
	}
	enumentry 'BorderShadow'{
		code_symbol='XRT_BORDER_SHADOW'
		resfile_symbol='BorderShadow'
	}
	enumentry 'BorderPlain'{
		code_symbol='XRT_BORDER_PLAIN'
		resfile_symbol='BorderPlain'
	}
	enumentry 'BorderEtchedIn'{
		code_symbol='XRT_BORDER_ETCHED_IN'
		resfile_symbol='BorderEtchedIn'
	}
	enumentry 'BorderEtchedOut'{
		code_symbol='XRT_BORDER_ETCHED_OUT'
		resfile_symbol='BorderEtchedOut'
	}
}
enumeration 'XrtFldCase' {
	typename='XmRxrtFldCase'
	enumentry '(As Is)'{
		code_symbol='XRTFLD_CASE_AS_IS'
		resfile_symbol='CASE_AS_IS'
	}
	enumentry 'As Is'{
		code_symbol='XRTFLD_CASE_AS_IS'
		resfile_symbol='CASE_AS_IS'
	}
	enumentry 'Lower'{
		code_symbol='XRTFLD_CASE_LOWER'
		resfile_symbol='CASE_LOWER'
	}
	enumentry 'Upper'{
		code_symbol='XRTFLD_CASE_UPPER'
		resfile_symbol='CASE_UPPER'
	}
}
enumeration 'XrtFldDispScrollBar' {
	typename='XmRxrtFldDispScrollBar'
	enumentry '(As Needed)'{
		code_symbol='XRTFLD_DISPSB_AS_NEEDED'
		resfile_symbol='DISPSB_AS_NEEDED'
	}
	enumentry 'As Needed'{
		code_symbol='XRTFLD_DISPSB_AS_NEEDED'
		resfile_symbol='DISPSB_AS_NEEDED'
	}
	enumentry 'Always'{
		code_symbol='XRTFLD_DISPSB_ALWAYS'
		resfile_symbol='DISPSB_AS_ALWAYS'
	}
	enumentry 'Never'{
		code_symbol='XRTFLD_DISPSB_NEVER'
		resfile_symbol='DISPSB_AS_NEVER'
	}
}
enumeration 'XrtFldError' {
	typename='XmRxrtFldError'
	enumentry '(None)'{
		code_symbol='XRTFLD_ERROR_NONE'
		resfile_symbol='ERROR_NONE'
	}
	enumentry 'Exceeded Length'{
		code_symbol='XRTFLD_ERROR_EXCEED_LENGTH'
		resfile_symbol='ERROR_EXCEED_LENGTH'
	}
	enumentry 'Exceeded Lines'{
		code_symbol='XRTFLD_ERROR_EXCEED_LINES'
		resfile_symbol='ERROR_EXCEED_LINES'
	}
	enumentry 'Invalid Character'{
		code_symbol='XRTFLD_ERROR_INVALID_CHAR'
		resfile_symbol='ERROR_INVALID_CHAR'
	}
	enumentry 'Invalid Data Type'{
		code_symbol='XRTFLD_ERROR_INVALID_DATATYPE'
		resfile_symbol='ERROR_INVALID_DATATYPE'
	}
	enumentry 'Null Value'{
		code_symbol='XRTFLD_ERROR_IS_NULL'
		resfile_symbol='ERROR_IS_NULL'
	}
	enumentry 'Does Not Match Mask'{
		code_symbol='XRTFLD_ERROR_NOMATCH_MASK'
		resfile_symbol='ERROR_NOMATCH_MASK'
	}
	enumentry 'Does Not Match Pick List'{
		code_symbol='XRTFLD_ERROR_NOMATCH_PICKLIST'
		resfile_symbol='ERROR_NOMATCH_PICKLIST'
	}
	enumentry 'Out of Range'{
		code_symbol='XRTFLD_ERROR_OUT_OF_RANGE'
		resfile_symbol='ERROR_OUT_OF_RANGE'
	}
	enumentry 'Validate Callback'{
		code_symbol='XRTFLD_ERROR_VALIDATECB'
		resfile_symbol='ERROR_VALIDATECB'
	}
	enumentry 'None'{
		code_symbol='XRTFLD_ERROR_NONE'
		resfile_symbol='ERROR_NONE'
	}
}
enumeration 'XrtFldFieldType' {
	typename='XmRxrtFldFieldType'
	enumentry '(String)'{
		code_symbol='XRTFLD_FIELDTYPE_STRING'
		resfile_symbol='FIELDTYPE_STRING'
	}
	enumentry 'Currency'{
		code_symbol='XRTFLD_FIELDTYPE_CURRENCY'
		resfile_symbol='FIELDTYPE_CURRENCY'
	}
	enumentry 'Date'{
		code_symbol='XRTFLD_FIELDTYPE_DATE'
		resfile_symbol='FIELDTYPE_DATE'
	}
	enumentry 'Float'{
		code_symbol='XRTFLD_FIELDTYPE_FLOAT'
		resfile_symbol='FIELDTYPE_FLOAT'
	}
	enumentry 'Integer'{
		code_symbol='XRTFLD_FIELDTYPE_INT'
		resfile_symbol='FIELDTYPE_INT'
	}
	enumentry 'String'{
		code_symbol='XRTFLD_FIELDTYPE_STRING'
		resfile_symbol='FIELDTYPE_STRING'
	}
	enumentry 'None'{
		code_symbol='XRTFLD_FIELDTYPE_NONE'
		resfile_symbol='FIELDTYPE_NONE'
	}
}
enumeration 'XrtFldFormat' {
	typename='XmRxrtFldFormat'
	enumentry '(Default)'{
		code_symbol='XRTFLD_FORMAT_DEFAULT'
		resfile_symbol='FORMAT_DEFAULT'
	}
	enumentry 'Binary'{
		code_symbol='XRTFLD_FORMAT_BINARY'
		resfile_symbol='FORMAT_BINARY'
	}
	enumentry 'Currency'{
		code_symbol='XRTFLD_FORMAT_CURRENCY'
		resfile_symbol='FORMAT_CURRENCY'
	}
	enumentry 'Currency International'{
		code_symbol='XRTFLD_FORMAT_CURRENCY_INTL'
		resfile_symbol='FORMAT_CURRENCY_INTL'
	}
	enumentry 'General'{
		code_symbol='XRTFLD_FORMAT_GENERAL'
		resfile_symbol='FORMAT_GENERAL'
	}
	enumentry 'Fixed'{
		code_symbol='XRTFLD_FORMAT_FIXED'
		resfile_symbol='FORMAT_FIXED'
	}
	enumentry 'Hexadecimal'{
		code_symbol='XRTFLD_FORMAT_HEX'
		resfile_symbol='FORMAT_HEX'
	}
	enumentry 'Octal'{
		code_symbol='XRTFLD_FORMAT_OCTAL'
		resfile_symbol='FORMAT_OCTAL'
	}
	enumentry 'Percent'{
		code_symbol='XRTFLD_FORMAT_PERCENT'
		resfile_symbol='FORMAT_PERCENT'
	}
	enumentry 'Scientific'{
		code_symbol='XRTFLD_FORMAT_SCIENTIFIC'
		resfile_symbol='FORMAT_SCIENTIFIC'
	}
	enumentry 'Thousands'{
		code_symbol='XRTFLD_FORMAT_THOUSANDS'
		resfile_symbol='FORMAT_THOUSANDS'
	}
}
enumeration 'XrtFldMatchMask' {
	typename='XmRxrtFldMatchMask'
	enumentry '(Match All)'{
		code_symbol='XRTFLD_MATCH_ALL'
		resfile_symbol='MATCH_ALL'
	}
	enumentry 'Match All'{
		code_symbol='XRTFLD_MATCH_ALL'
		resfile_symbol='MATCH_ALL'
	}
	enumentry 'Match Partial Left to RIght'{
		code_symbol='XRTFLD_MATCH_PARTIAL_L_TO_R'
		resfile_symbol='MATCH_PARTIAL_L_TO_R'
	}
	enumentry 'Match Partial Right To Left'{
		code_symbol='XRTFLD_MATCH_PARTIAL_R_TO_L'
		resfile_symbol='MATCH_PARTIAL_R_TO_L'
	}
}
enumeration 'XrtFldNegFormat' {
	typename='XmRxrtFldNegativeFormat'
	enumentry '(As Is)'{
		code_symbol='XRTFLD_NEG_AS_IS'
		resfile_symbol='NEG_AS_IS'
	}
	enumentry 'As Is'{
		code_symbol='XRTFLD_NEG_AS_IS'
		resfile_symbol='NEG_AS_IS'
	}
	enumentry 'Locale'{
		code_symbol='XRTFLD_NEG_LOCALE'
		resfile_symbol='NEG_LOCALE'
	}
	enumentry 'Parentheses'{
		code_symbol='XRTFLD_NEG_PARENTHESES'
		resfile_symbol='NEG_PARENTHESES'
	}
}
enumeration 'XrtFldRange' {
	typename='XmRxrtFldRange'
	enumentry '(Default)'{
		code_symbol='XRTFLD_RANGE_DEFAULT'
		resfile_symbol='RANGE_DEFAULT'
	}
	enumentry 'Char'{
		code_symbol='XRTFLD_RANGE_CHAR'
		resfile_symbol='RANGE_CHAR'
	}
	enumentry 'Double'{
		code_symbol='XRTFLD_RANGE_DOUBLE'
		resfile_symbol='RANGE_DOUBLE'
	}
	enumentry 'Float'{
		code_symbol='XRTFLD_RANGE_FLOAT'
		resfile_symbol='RANGE_FLOAT'
	}
	enumentry 'Integer'{
		code_symbol='XRTFLD_RANGE_INT'
		resfile_symbol='RANGE_INT'
	}
	enumentry 'Long'{
		code_symbol='XRTFLD_RANGE_LONG'
		resfile_symbol='RANGE_LONG'
	}
	enumentry 'Short'{
		code_symbol='XRTFLD_RANGE_SHORT'
		resfile_symbol='RANGE_SHORT'
	}
	enumentry 'Unsigned Char'{
		code_symbol='XRTFLD_RANGE_UNSIGNED_CHAR'
		resfile_symbol='RANGE_UNSIGNED_CHAR'
	}
	enumentry 'Unsigned Integer'{
		code_symbol='XRTFLD_RANGE_UNSIGNED_INT'
		resfile_symbol='RANGE_UNSIGNED_INT'
	}
	enumentry 'Unsigned Long'{
		code_symbol='XRTFLD_RANGE_UNSIGNED_LONG'
		resfile_symbol='RANGE_UNSIGNED_LONG'
	}
	enumentry 'Unsigned Short'{
		code_symbol='XRTFLD_RANGE_UNSIGNED_SHORT'
		resfile_symbol='RANGE_UNSIGNED_SHORT'
	}
}
enumeration 'XrtLblBorderType' {
	typename='XmRxrtLblBorderType'
	enumentry '(In)'{
		code_symbol='	XRTLBL_BORDER_IN'
		resfile_symbol='BORDER_IN'
	}
	enumentry 'None'{
		code_symbol='	XRTLBL_BORDER_NONE'
		resfile_symbol='BORDER_NONE'
	}
	enumentry 'Etched In'{
		code_symbol='	XRTLBL_BORDER_ETCHED_IN'
		resfile_symbol='BORDER_ETCHED_IN'
	}
	enumentry 'Etched Out'{
		code_symbol='	XRTLBL_BORDER_ETCHED_OUT'
		resfile_symbol='BORDER_ETCHED_OUT'
	}
	enumentry 'In'{
		code_symbol='	XRTLBL_BORDER_IN'
		resfile_symbol='BORDER_IN'
	}
	enumentry 'Out'{
		code_symbol='XRTLBL_BORDER_OUT'
		resfile_symbol='BORDER_OUT'
	}
	enumentry 'Shadow'{
		code_symbol='XRTLBL_BORDER_SHADOW'
		resfile_symbol='BORDER_SHADOW'
	}
	enumentry 'Plain'{
		code_symbol='XRTLBL_BORDER_PLAIN'
		resfile_symbol='BORDER_PLAIN'
	}
	enumentry 'Bezel'{
		code_symbol='XRTLBL_BORDER_BEZEL'
		resfile_symbol='BORDER_BEZEL'
	}
}
enumeration 'XrtLblRotation' {
	typename='XmRxrtLblRotation'
	enumentry '(None)'{
		code_symbol='XRTLBL_ROTATE_NONE'
		resfile_symbol='ROTATE_NONE'
	}
	enumentry 'None'{
		code_symbol='XRTLBL_ROTATE_NONE'
		resfile_symbol='ROTATE_NONE'
	}
	enumentry '90'{
		code_symbol='XRTLBL_ROTATE_90'
		resfile_symbol='ROTATE_90'
	}
	enumentry '270'{
		code_symbol='XRTLBL_ROTATE_270'
		resfile_symbol='ROTATE_270'
	}
}
enumeration 'XrtNumMethod' {
	typename='XtRXrtNumMethod'
	enumentry '(Round)'{
		code_symbol='XRT_NUM_ROUND'
		resfile_symbol='NumRound'
	}
	enumentry 'Precision'{
		code_symbol='XRT_NUM_PRECISION'
		resfile_symbol='NumPrecision'
	}
	enumentry 'Round'{
		code_symbol='XRT_NUM_ROUND'
		resfile_symbol='NumRound'
	}
}
enumeration 'XrtOriginPlacement' {
	typename='XtRXrtOriginPlacement'
	enumentry '(Auto)'{
		code_symbol='XRT_ORIGIN_AUTO'
		resfile_symbol='OriginAuto'
	}
	enumentry 'Auto'{
		code_symbol='XRT_ORIGIN_AUTO'
		resfile_symbol='OriginAuto'
	}
	enumentry 'Zero'{
		code_symbol='XRT_ORIGIN_ZERO'
		resfile_symbol='OriginZero'
	}
	enumentry 'Min'{
		code_symbol='XRT_ORIGIN_MIN'
		resfile_symbol='OriginMin'
	}
	enumentry 'Max'{
		code_symbol='XRT_ORIGIN_MAX'
		resfile_symbol='OriginMax'
	}
}
enumeration 'XrtPieOrder' {
	typename='XtRXrtPieOrder'
	enumentry '(DataOrder)'{
		code_symbol='XRT_PIEORDER_DATA_ORDER'
		resfile_symbol='PieOrderDataOrder'
	}
	enumentry 'Ascending'{
		code_symbol='XRT_PIEORDER_ASCENDING'
		resfile_symbol='PieOrderAscending'
	}
	enumentry 'Descending'{
		code_symbol='XRT_PIEORDER_DESCENDING'
		resfile_symbol='PieOrderDescending'
	}
	enumentry 'DataOrder'{
		code_symbol='XRT_PIEORDER_DATA_ORDER'
		resfile_symbol='PieOrderDataOrder'
	}
}
enumeration 'XrtPieThresholdMethod' {
	typename='XtRXrtPieThresholdMethod'
	enumentry '(PieSliceCutoff)'{
		code_symbol='XRT_PIE_SLICE_CUTOFF'
		resfile_symbol='PieSiceCutoff'
	}
	enumentry 'PieSliceCutoff'{
		code_symbol='XRT_PIE_SLICE_CUTOFF'
		resfile_symbol='PieSliceCutoff'
	}
	enumentry 'PiePercentile'{
		code_symbol='XRT_PIE_PERCENTILE'
		resfile_symbol='PiePercentile'
	}
}
enumeration 'XrtRotate' {
	typename='XtRXrtRotate'
	enumentry '(RotateNone)'{
		code_symbol='XRT_ROTATE_NONE'
		resfile_symbol='RotateNone'
	}
	enumentry 'RotateNone'{
		code_symbol='XRT_ROTATE_NONE'
		resfile_symbol='RotateNone'
	}
	enumentry 'Rotate90'{
		code_symbol='XRT_ROTATE_90'
		resfile_symbol='Rotate90'
	}
	enumentry 'Rotate270'{
		code_symbol='XRT_ROTATE_270'
		resfile_symbol='Rotate270'
	}
}
enumeration 'XrtSpinArrowLayout' {
	typename='XmRxrtSpinArrowLayout'
	enumentry '(Split)'{
		code_symbol='XRTSPIN_ARROWS_SPLIT'
		resfile_symbol='ARROWS_SPLIT'
	}
	enumentry 'Beginning'{
		code_symbol='XRTSPIN_ARROWS_BEGINNING'
		resfile_symbol='ARROWS_BEGINNING'
	}
	enumentry 'End'{
		code_symbol='XRTSPIN_ARROWS_END'
		resfile_symbol='ARROWS_END'
	}
	enumentry 'Split'{
		code_symbol='XRTSPIN_ARROWS_SPLIT'
		resfile_symbol='ARROWS_SPLIT'
	}
}
enumeration 'XrtSpinType' {
	typename='XmRxrtSpinType'
	enumentry '(Counter)'{
		code_symbol='XRTSPIN_TYPE_COUNTER'
		resfile_symbol='TYPE_COUNTER'
	}
	enumentry 'Counter'{
		code_symbol='XRTSPIN_TYPE_COUNTER'
		resfile_symbol='TYPE_COUNTER'
	}
	enumentry 'Pick List'{
		code_symbol='XRTSPIN_TYPE_PICKLIST'
		resfile_symbol='TYPE_PICKLIST'
	}
}
enumeration 'XrtTblAlignment' {
	typename='XmRxrtTblAlignment'
	enumentry '(Top Begin)'{
		code_symbol='XRTTBL_ALIGNMENT_TOPBEGIN'
		resfile_symbol='ALIGNMENT_TOPBEGIN'
	}
	enumentry 'Top Begin'{
		code_symbol='XRTTBL_ALIGNMENT_TOPBEGIN'
		resfile_symbol='ALIGNMENT_TOPBEGIN'
	}
	enumentry 'Top Center'{
		code_symbol='XRTTBL_ALIGNMENT_TOPCENTER'
		resfile_symbol='ALIGNMENT_TOPCENTER'
	}
	enumentry 'Top End'{
		code_symbol='XRTTBL_ALIGNMENT_TOPEND'
		resfile_symbol='ALIGNMENT_TOPEND'
	}
	enumentry 'Middle Begin'{
		code_symbol='XRTTBL_ALIGNMENT_MIDDLEBEGIN'
		resfile_symbol='ALIGNMENT_MIDDLEBEGIN'
	}
	enumentry 'Middle Center'{
		code_symbol='XRTTBL_ALIGNMENT_MIDDLECENTER'
		resfile_symbol='ALIGNMENT_MIDDLECENTER'
	}
	enumentry 'Middle End'{
		code_symbol='XRTTBL_ALIGNMENT_MIDDLEEND'
		resfile_symbol='ALIGNMENT_MIDDLEEND'
	}
	enumentry 'Bottom Begin'{
		code_symbol='XRTTBL_ALIGNMENT_BOTTOMBEGIN'
		resfile_symbol='ALIGNMENT_BOTTOMBEGIN'
	}
	enumentry 'Bottom Center'{
		code_symbol='XRTTBL_ALIGNMENT_BOTTOMCENTER'
		resfile_symbol='ALIGNMENT_BOTTOMCENTER'
	}
	enumentry 'Bottom End'{
		code_symbol='XRTTBL_ALIGNMENT_BOTTOMEND'
		resfile_symbol='ALIGNMENT_BOTTOMEND'
	}
}
enumeration 'XrtTblAttachment' {
	typename='XmRxrtTblAttachment'
	enumentry '(Cells)'{
		code_symbol='XRTTBL_ATTACH_CELLS'
		resfile_symbol='ATTACH_CELLS'
	}
	enumentry 'Cells'{
		code_symbol='XRTTBL_ATTACH_CELLS'
		resfile_symbol='ATTACH_CELLS'
	}
	enumentry 'Side'{
		code_symbol='XRTTBL_ATTACH_SIDE'
		resfile_symbol='ATTACH_SIDE'
	}
}
enumeration 'XrtTblBorderSide' {
	typename='XmRxrtTblBorderSides'
	enumentry '(All)'{
		code_symbol='XRTTBL_BORDERSIDE_ALL'
		resfile_symbol='BORDERSIDE_ALL'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_BORDERSIDE_NONE'
		resfile_symbol='BORDERSIDE_NONE'
	}
	enumentry 'All'{
		code_symbol='XRTTBL_BORDERSIDE_ALL'
		resfile_symbol='BORDERSIDE_ALL'
	}
	enumentry 'Left'{
		code_symbol='XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_LEFT'
	}
	enumentry 'Top'{
		code_symbol='XRTTBL_BORDERSIDE_TOP'
		resfile_symbol='BORDERSIDE_TOP'
	}
	enumentry 'Top & Left'{
		code_symbol='XRTTBL_BORDERSIDE_TOP | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_TOP+BORDERSIDE_LEFT'
	}
	enumentry 'Bottom'{
		code_symbol='XRTTBL_BORDERSIDE_BOTTOM'
		resfile_symbol='BORDERSIDE_BOTTOM'
	}
	enumentry 'Bottom & Left'{
		code_symbol='XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_BOTTOM+BORDERSIDE_LEFT'
	}
	enumentry 'Bottom & Top'{
		code_symbol='XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_TOP'
		resfile_symbol='BORDERSIDE_BOTTOM+BORDERSIDE_TOP'
	}
	enumentry 'Bottom & Top & Left'{
		code_symbol='XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_TOP | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_BOTTOM+BORDERSIDE_TOP+BORDERSIDE_LEFT'
	}
	enumentry 'Right'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT'
		resfile_symbol='BORDERSIDE_RIGHT'
	}
	enumentry 'Right & Left'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_LEFT'
	}
	enumentry 'Right & Top'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_TOP'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_TOP'
	}
	enumentry 'Right & Top & Left'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_TOP | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_TOP+BORDERSIDE_LEFT'
	}
	enumentry 'Right & Bottom'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_BOTTOM'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_BOTTOM'
	}
	enumentry 'Right & Bottom & Left'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_BOTTOM+BORDERSIDE_LEFT'
	}
	enumentry 'Right & Bottom & Top'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_TOP'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_BOTTOM+BORDERSIDE_TOP'
	}
	enumentry 'Right & Bottom & Top & Left'{
		code_symbol='XRTTBL_BORDERSIDE_RIGHT | XRTTBL_BORDERSIDE_BOTTOM | XRTTBL_BORDERSIDE_TOP | XRTTBL_BORDERSIDE_LEFT'
		resfile_symbol='BORDERSIDE_RIGHT+BORDERSIDE_BOTTOM+BORDERSIDE_TOP+BORDERSIDE_LEFT'
	}
}
enumeration 'XrtTblBorderType' {
	typename='XmRxrtTblBorderType'
	enumentry '(In)'{
		code_symbol='XRTTBL_BORDER_IN'
		resfile_symbol='BORDER_IN'
	}
	enumentry 'In'{
		code_symbol='XRTTBL_BORDER_IN'
		resfile_symbol='BORDER_IN'
	}
	enumentry 'Etched In'{
		code_symbol='XRTTBL_BORDER_ETCHED_IN'
		resfile_symbol='BORDER_ETCHED_IN'
	}
	enumentry 'Etched Out'{
		code_symbol='XRTTBL_BORDER_ETCHED_OUT'
		resfile_symbol='BORDER_ETCHED_OUT'
	}
	enumentry 'Out'{
		code_symbol='XRTTBL_BORDER_OUT'
		resfile_symbol='BORDER_OUT'
	}
	enumentry 'Plain'{
		code_symbol='XRTTBL_BORDER_PLAIN'
		resfile_symbol='BORDER_PLAIN'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_BORDER_NONE'
		resfile_symbol='BORDER_NONE'
	}
	enumentry 'Frame In'{
		code_symbol='XRTTBL_BORDER_FRAME_IN'
		resfile_symbol='BORDER_FRAME_IN'
	}
	enumentry 'Frame Out'{
		code_symbol='XRTTBL_BORDER_FRAME_OUT'
		resfile_symbol='BORDER_FRAME_OUT'
	}
}
enumeration 'XrtTblCase' {
	typename='XmRxrtTblCase'
	enumentry '(As Is)'{
		code_symbol='XRTTBL_CASE_AS_IS'
		resfile_symbol='CASE_AS_IS'
	}
	enumentry 'As Is'{
		code_symbol='XRTTBL_CASE_AS_IS'
		resfile_symbol='CASE_AS_IS'
	}
	enumentry 'Lower'{
		code_symbol='XRTTBL_CASE_LOWER'
		resfile_symbol='CASE_LOWER'
	}
	enumentry 'Upper'{
		code_symbol='XRTTBL_CASE_UPPER'
		resfile_symbol='CASE_UPPER'
	}
}
enumeration 'XrtTblColumnPlacement' {
	typename='XmRxrtTblColumnPlacement'
	enumentry 'Left'{
		code_symbol='XRTTBL_PLACE_LEFT'
		resfile_symbol='PLACE_LEFT'
	}
	enumentry 'Right'{
		code_symbol='XRTTBL_PLACE_RIGHT'
		resfile_symbol='PLACE_RIGHT'
	}
}
enumeration 'XrtTblDataType' {
	typename='XmRxrtTblDataType'
	enumentry '(String)'{
		code_symbol='XRTTBL_TYPE_STRING'
		resfile_symbol='TYPE_STRING'
	}
	enumentry 'String'{
		code_symbol='XRTTBL_TYPE_STRING'
		resfile_symbol='TYPE_STRING'
	}
	enumentry 'Boolean'{
		code_symbol='XRTTBL_TYPE_BOOLEAN'
		resfile_symbol='TYPE_BOOLEAN'
	}
	enumentry 'Double'{
		code_symbol='XRTTBL_TYPE_DOUBLE'
		resfile_symbol='TYPE_DOUBLE'
	}
	enumentry 'Float'{
		code_symbol='XRTTBL_TYPE_FLOAT'
		resfile_symbol='TYPE_FLOAT'
	}
	enumentry 'Int'{
		code_symbol='XRTTBL_TYPE_INT'
		resfile_symbol='TYPE_INT'
	}
	enumentry 'Field Currency'{
		code_symbol='XRTTBL_TYPE_FIELD_CURRENCY'
		resfile_symbol='TYPE_FIELD_CURRENCY'
	}
	enumentry 'Field Date'{
		code_symbol='XRTTBL_TYPE_FIELD_DATE'
		resfile_symbol='TYPE_FIELD_DATE'
	}
	enumentry 'Field Float'{
		code_symbol='XRTTBL_TYPE_FIELD_FLOAT'
		resfile_symbol='TYPE_FIELD_FLOAT'
	}
	enumentry 'Field Int'{
		code_symbol='XRTTBL_TYPE_FIELD_INT'
		resfile_symbol='TYPE_FIELD_INT'
	}
	enumentry 'Field String'{
		code_symbol='XRTTBL_TYPE_FIELD_STRING'
		resfile_symbol='TYPE_FIELD_STRING'
	}
}
enumeration 'XrtTblDispScrollBar' {
	typename='XmRxrtTblDispScrollBar'
	enumentry '(As Needed)'{
		code_symbol='XRTTBL_DISPSB_AS_NEEDED'
		resfile_symbol='DISPSB_AS_NEEDED'
	}
	enumentry 'As Needed'{
		code_symbol='XRTTBL_DISPSB_AS_NEEDED'
		resfile_symbol='DISPSB_AS_NEEDED'
	}
	enumentry 'Always'{
		code_symbol='XRTTBL_DISPSB_ALWAYS'
		resfile_symbol='DISPSB_ALWAYS'
	}
	enumentry 'Never'{
		code_symbol='XRTTBL_DISPSB_NEVER'
		resfile_symbol='DISPSB_NEVER'
	}
}
enumeration 'XrtTblDoubleBuffer' {
	typename='XmRxrtTblDoubleBuffer'
	enumentry '(Cell)'{
		code_symbol='XRTTBL_DOUBLEBUFFER_CELL'
		resfile_symbol='DOUBLEBUFFER_CELL'
	}
	enumentry 'Cell'{
		code_symbol='XRTTBL_DOUBLEBUFFER_CELL'
		resfile_symbol='DOUBLEBUFFER_CELL'
	}
	enumentry 'Window'{
		code_symbol='XRTTBL_DOUBLEBUFFER_WINDOW'
		resfile_symbol='DOUBLEBUFFER_WINDOW'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_DOUBLEBUFFER_NONE'
		resfile_symbol='DOUBLEBUFFER_NONE'
	}
}
enumeration 'XrtTblJumpScroll' {
	typename='XmRxrtTblJumpScroll'
	enumentry '(None)'{
		code_symbol='XRTTBL_JUMP_NONE'
		resfile_symbol='JUMP_NONE'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_JUMP_NONE'
		resfile_symbol='JUMP_NONE'
	}
	enumentry 'Horizontal'{
		code_symbol='XRTTBL_JUMP_HORIZONTAL'
		resfile_symbol='JUMP_HORIZONTAL'
	}
	enumentry 'Vertical'{
		code_symbol='XRTTBL_JUMP_VERTICAL'
		resfile_symbol='JUMP_VERTICAL'
	}
	enumentry 'All'{
		code_symbol='XRTTBL_JUMP_ALL'
		resfile_symbol='JUMP_ALL'
	}
}
enumeration 'XrtTblLocation' {
	typename='XmRxrtTblLocation'
	enumentry '(None)'{
		code_symbol='XRTTBL_LOCATION_NONE'
		resfile_symbol='LOCATION_NONE'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_LOCATION_NONE'
		resfile_symbol='LOCATION_NONE'
	}
	enumentry 'Top'{
		code_symbol='XRTTBL_LOCATION_TOP'
		resfile_symbol='LOCATION_TOP'
	}
	enumentry 'Left'{
		code_symbol='XRTTBL_LOCATION_LEFT'
		resfile_symbol='LOCATION_LEFT'
	}
	enumentry 'Bottom'{
		code_symbol='XRTTBL_LOCATION_BOTTOM'
		resfile_symbol='LOCATION_BOTTOM'
	}
	enumentry 'Right'{
		code_symbol='XRTTBL_LOCATION_RIGHT'
		resfile_symbol='LOCATION_RIGHT'
	}
}
enumeration 'XrtTblMode' {
	typename='XmRxrtTblMode'
	enumentry '(Table)'{
		code_symbol='XRTTBL_MODE_TABLE'
		resfile_symbol='MODE_TABLE'
	}
	enumentry 'Table'{
		code_symbol='XRTTBL_MODE_TABLE'
		resfile_symbol='MODE_TABLE'
	}
	enumentry 'List'{
		code_symbol='XRTTBL_MODE_LIST'
		resfile_symbol='MODE_LIST'
	}
}
enumeration 'XrtTblOverflow' {
	typename='XmRxrtTblOverflow'
	enumentry '(None)'{
		code_symbol='XRTTBL_OVERFLOW_NONE'
		resfile_symbol='OVERFLOW_NONE'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_OVERFLOW_NONE'
		resfile_symbol='OVERFLOW_NONE'
	}
	enumentry 'Horizontal'{
		code_symbol='XRTTBL_OVERFLOW_HORIZONTAL'
		resfile_symbol='OVERFLOW_HORIZONTAL'
	}
}
enumeration 'XrtTblPixmapLayout' {
	typename='XmRxrtTblPixmapLayout'
	enumentry '(Top Left)'{
		code_symbol='XRTTBL_PIXMAP_TOPLEFT'
		resfile_symbol='PIXMAP_TOPLEFT'
	}
	enumentry 'Top Left'{
		code_symbol='XRTTBL_PIXMAP_TOPLEFT'
		resfile_symbol='PIXMAP_TOPLEFT'
	}
	enumentry 'Top Center'{
		code_symbol='XRTTBL_PIXMAP_TOPCENTER'
		resfile_symbol='PIXMAP_TOPCENTER'
	}
	enumentry 'Top Right'{
		code_symbol='XRTTBL_PIXMAP_TOPRIGHT'
		resfile_symbol='PIXMAP_TOPRIGHT'
	}
	enumentry 'Middle Left'{
		code_symbol='XRTTBL_PIXMAP_MIDDLELEFT'
		resfile_symbol='PIXMAP_MIDDLELEFT'
	}
	enumentry 'Middle Center'{
		code_symbol='XRTTBL_PIXMAP_MIDDLECENTER'
		resfile_symbol='PIXMAP_MIDDLECENTER'
	}
	enumentry 'Middle Right'{
		code_symbol='XRTTBL_PIXMAP_MIDDLERIGHT'
		resfile_symbol='PIXMAP_MIDDLERIGHT'
	}
	enumentry 'Bottom Left'{
		code_symbol='XRTTBL_PIXMAP_BOTTOMLEFT'
		resfile_symbol='PIXMAP_BOTTOMLEFT'
	}
	enumentry 'Bottom Center'{
		code_symbol='XRTTBL_PIXMAP_BOTTOMCENTER'
		resfile_symbol='PIXMAP_BOTTOMCENTER'
	}
	enumentry 'Bottom Right'{
		code_symbol='XRTTBL_PIXMAP_BOTTOMRIGHT'
		resfile_symbol='PIXMAP_BOTTOMRIGHT'
	}
}
enumeration 'XrtTblRepaint' {
	typename='XmRxrtTblRepaint'
	enumentry '(Repaint On)'{
		code_symbol='XRTTBL_REPAINT_ON'
		resfile_symbol='REPAINT_ON'
	}
	enumentry 'Repaint On'{
		code_symbol='XRTTBL_REPAINT_ON'
		resfile_symbol='REPAINT_ON'
	}
	enumentry 'Repaint Off'{
		code_symbol='XRTTBL_REPAINT_OFF'
		resfile_symbol='REPAINT_OFF'
	}
	enumentry 'Repaint Nocalc'{
		code_symbol='XRTTBL_REPAINT_NOCALC'
		resfile_symbol='REPAINT_NOCALC'
	}
}
enumeration 'XrtTblResize' {
	typename='XmRxrtTblResize'
	enumentry 'None'{
		code_symbol='XRTTBL_RESIZE_NONE'
		resfile_symbol='RESIZE_NONE'
	}
	enumentry 'All'{
		code_symbol='XRTTBL_RESIZE_ALL'
		resfile_symbol='RESIZE_ALL'
	}
	enumentry 'Horizontal'{
		code_symbol='XRTTBL_RESIZE_HORIZONTAL'
		resfile_symbol='RESIZE_HORIZONTAL'
	}
	enumentry 'Vertical'{
		code_symbol='XRTTBL_RESIZE_VERTICAL'
		resfile_symbol='RESIZE_VERTICAL'
	}
}
enumeration 'XrtTblRowPlacement' {
	typename='XmRxrtTblRowPlacement'
	enumentry 'Top'{
		code_symbol='XRTTBL_PLACE_TOP'
		resfile_symbol='PLACE_TOP'
	}
	enumentry 'Bottom'{
		code_symbol='XRTTBL_PLACE_BOTTOM'
		resfile_symbol='PLACE_BOTTOM'
	}
}
enumeration 'XrtTblSBPosition' {
	typename='XmRxrtTblScrollBarPosition'
	enumentry '(Cells)'{
		code_symbol='XRTTBL_SBPOSITION_CELLS'
		resfile_symbol='SBPOSITION_CELLS'
	}
	enumentry 'Cells'{
		code_symbol='XRTTBL_SBPOSITION_CELLS'
		resfile_symbol='SBPOSITION_CELLS'
	}
	enumentry 'Side'{
		code_symbol='XRTTBL_SBPOSITION_SIDE'
		resfile_symbol='SBPOSITION_SIDE'
	}
}
enumeration 'XrtTblSelectionPolicy' {
	typename='XmRxrtTblSelectionPolicy'
	enumentry '(None)'{
		code_symbol='XRTTBL_SELECT_NONE'
		resfile_symbol='SELECT_NONE'
	}
	enumentry 'None'{
		code_symbol='XRTTBL_SELECT_NONE'
		resfile_symbol='SELECT_NONE'
	}
	enumentry 'Single'{
		code_symbol='XRTTBL_SELECT_SINGLE'
		resfile_symbol='SELECT_SINGLE'
	}
	enumentry 'Range'{
		code_symbol='XRTTBL_SELECT_RANGE'
		resfile_symbol='SELECT_RANGE'
	}
	enumentry 'Multiple Range'{
		code_symbol='XRTTBL_SELECT_MULTIRANGE'
		resfile_symbol='SELECT_MULTIRANGE'
	}
}
enumeration 'XrtTblValidatePolicy' {
	typename='XmRxrtTblValidatePolicy'
	enumentry '(User Edit)'{
		code_symbol='XRTTBL_VALIDATE_USER_EDIT'
		resfile_symbol='VALIDATE_USER_EDIT'
	}
	enumentry 'Never'{
		code_symbol='XRTTBL_VALIDATE_NEVER'
		resfile_symbol='VALIDATE_NEVER'
	}
	enumentry 'User Edit'{
		code_symbol='XRTTBL_VALIDATE_USER_EDIT'
		resfile_symbol='VALIDATE_USER_EDIT'
	}
	enumentry 'Set'{
		code_symbol='XRTTBL_VALIDATE_SET'
		resfile_symbol='VALIDATE_SET'
	}
	enumentry 'Always'{
		code_symbol='XRTTBL_VALIDATE_ALWAYS'
		resfile_symbol='VALIDATE_ALWAYS'
	}
}
enumeration 'XrtTblXmStringGetMode' {
	typename='XmRxrtTblXmStringGetMode'
	enumentry '(Default)'{
		code_symbol='XRTTBL_GET_DEFAULT'
		resfile_symbol='GET_DEFAULT'
	}
	enumentry 'Default'{
		code_symbol='XRTTBL_GET_DEFAULT'
		resfile_symbol='GET_DEFAULT'
	}
	enumentry 'XmString'{
		code_symbol='XRTTBL_GET_XMSTRING'
		resfile_symbol='GET_XMSTRING'
	}
	enumentry 'String'{
		code_symbol='XRTTBL_GET_STRING'
		resfile_symbol='GET_STRING'
	}
}
enumeration 'XrtTblXmStringSetMode' {
	typename='XmRxrtTblXmStringSetMode'
	enumentry '(Default)'{
		code_symbol='XRTTBL_SET_DEFAULT'
		resfile_symbol='SET_DEAFAULT'
	}
	enumentry 'Default'{
		code_symbol='XRTTBL_SET_DEFAULT'
		resfile_symbol='SET_DEAFAULT'
	}
	enumentry 'XmString'{
		code_symbol='XRTTBL_SET_XMSTRING'
		resfile_symbol='SET_XMSTRING'
	}
	enumentry 'String'{
		code_symbol='XRTTBL_SET_STRING'
		resfile_symbol='SET_STRING'
	}
	enumentry 'Examine'{
		code_symbol='XRTTBL_SET_EXAMINE'
		resfile_symbol='SET_EXAMINE'
	}
}
enumeration 'XrtTimeUnit' {
	typename='XtRXrtTimeUnit'
	enumentry '(TMUnitSeconds)'{
		code_symbol='XRT_TMUNIT_SECONDS'
		resfile_symbol='TmUnitSeconds'
	}
	enumentry 'TMUnitSeconds'{
		code_symbol='XRT_TMUNIT_SECONDS'
		resfile_symbol='TmUnitSeconds'
	}
	enumentry 'TMUnitMinutes'{
		code_symbol='XRT_TMUNIT_MINUTES'
		resfile_symbol='TmUnitMinutes'
	}
	enumentry 'TMUnitHours'{
		code_symbol='XRT_TMUNIT_HOURS'
		resfile_symbol='TmUnitHours'
	}
	enumentry 'TMUnitDays'{
		code_symbol='XRT_TMUNIT_DAYS'
		resfile_symbol='TmUnitDays'
	}
	enumentry 'TMUnitWeeks'{
		code_symbol='XRT_TMUNIT_WEEKS'
		resfile_symbol='TmUnitWeeks'
	}
	enumentry 'TMUnitMonths'{
		code_symbol='XRT_TMUNIT_MONTHS'
		resfile_symbol='TmUnitMonths'
	}
	enumentry 'TMUnitYears'{
		code_symbol='XRT_TMUNIT_YEARS'
		resfile_symbol='TmUnitYears'
	}
}
enumeration 'XrtType' {
	typename='XtRXrtType'
	enumentry '(Plot)'{
		code_symbol='XRT_TYPE_PLOT'
		resfile_symbol='TypePlot'
	}
	enumentry 'Plot'{
		code_symbol='XRT_TYPE_PLOT'
		resfile_symbol='TypePlot'
	}
	enumentry 'Bar'{
		code_symbol='XRT_TYPE_BAR'
		resfile_symbol='TypeBar'
	}
	enumentry 'Pie'{
		code_symbol='XRT_TYPE_PIE'
		resfile_symbol='TypePie'
	}
	enumentry 'StackingBar'{
		code_symbol='XRT_TYPE_STACKING_BAR'
		resfile_symbol='TypeStackingBar'
	}
	enumentry 'Area'{
		code_symbol='XRT_TYPE_AREA'
		resfile_symbol='TypeArea'
	}
}
header 'Xm/XrtLabel.h'
header 'Xm/XrtTable.h'
cheader 'Xm/Xrt3d.h'
cheader 'Xm/XrtField.h'
cheader 'Xm/XrtGraph.h'
cheader 'Xm/XrtLabel.h'
cheader 'Xm/XrtTable.h'
cheader 'Xmu/Converters.h'
alias 'XmRxrtFldDecimalPlaces' {
	to_name='XmRInt'
}
alias 'XmRxrtFldInt' {
	to_name='XmRInt'
}
alias 'XmRxrtFldPixel' {
	to_name='XmRPixel'
}
alias 'XtRXrtString' {
	to_name='XmRString'
}
converter 'XmRPixmap' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRStringTable' {
}
converter 'XmRxrtFldDate' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtFldDateIncrement' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtFldDateList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtFldFloat' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtFldFloatList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtFldIntList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtLblPixmap' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblAlignmentSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblBooleanSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblBorderSidesSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblBorderTypeSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblCaseSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblCellSize' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblCellSizeSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblCellValues' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblClipPixmapSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblColorSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblContext' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblDataTypeSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblDoubleBuffer' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblFontListSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblInt' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblIntSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblMode' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblOverflowSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblPSFontMapList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblPixmapLayoutSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblPixmapSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblRange' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblRangeList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblRepaint' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblStringSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblWidget' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblWidgetSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblWidgetShadowSeries' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblXmStringGetMode' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblXmStringList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XmRxrtTblXmStringSetMode' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRCursor' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRFont' {
	proc_name='XtCvtStringToFont'
	dialog='xd_font_dialog_create'
}
converter 'XtRXrt3dContourStyles' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dData' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dDistnTable' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dDouble' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dGridLines' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dProject' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dStrings' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dTextList' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dValueLabels' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrt3dXYColors' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrtData' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrtDataStyle' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrtDataStyles' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrtStrings' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
converter 'XtRXrtValueLabels' {
	add_in_xd=TRUE
	add_in_code=TRUE
}
popup 'xd_colour_dialog_create' {
	dialog_init='xd_colour_dialog_initialise'
}
popup 'xd_font_dialog_create' {
	dialog_init='xd_font_dialog_initialise'
}
popup 'xd_fsb_dialog_create' {
	dialog_init='xd_fsb_dialog_initialise'
}
popup 'xd_pixmap_dialog_create' {
	dialog_init='xd_pixmap_dialog_initialise'
}
popup 'xd_string_dialog_create' {
	dialog_init='xd_string_dialog_initialise'
}
page 'display'
page 'margins'
page 'settings'
page 'callbacks'
page 'misc'
page 'Axis'
page 'Bar'
page 'DataSettings'
page 'DataStyles'
page 'DrawOpts'
page 'Footer'
page 'Graph'
page 'Header'
page 'Labels'
page 'Legend'
page 'Marker'
page 'Pie'
page 'X_Axis1'
page 'X_Axis2'
page 'XAxis'
page 'Y_Axis1'
page 'Y_Axis2'
page 'Y2_Axis1'
page 'Y2_Axis2'
page 'YAxis'
page 'ZAxis'
page 'Row/Col Options'
page 'Widgets'
page 'Text Contexts'
page 'Text Series'
page 'Other Contexts'
page 'Other Series'
page 'Constraint'
page 'Cursor'
page 'Scroll Bars'
page 'Label'
page 'Contours'
page 'TextAttach'
page 'readonly'
page 'values'
page 'new'
page 'new1'
page 'Table wide'
page 'Child Widget'
page 'Cell/Label Context'
page 'Cell-only Series'
page 'Cell/Label Series'
page 'Cell-only Context'
page 'Label-only '
page 'Other'
page 'Table wide 2'
page 'Table wide 3'
family 'XRT/family' {
	widget='xtXrt3dWidgetClass'
	widget='xtXrtGraphWidgetClass'
	widget='xtXrtTableWidgetClass'
	widget='xtXrtLabelWidgetClass'
	widget='xmXrtFieldWidgetClass'
	widget='xmXrtStringFieldWidgetClass'
	widget='xmXrtDateFieldWidgetClass'
	widget='xmXrtFloatFieldWidgetClass'
	widget='xmXrtCurrencyFieldWidgetClass'
	widget='xmXrtIntFieldWidgetClass'
	widget='xmXrtComboBoxWidgetClass'
	widget='xmXrtSpinBoxWidgetClass'
	enumeration='Alignment'
	enumeration='LabelType'
	enumeration='Orientation'
	enumeration='StringDirection'
	enumeration='Xrt3dAdjust'
	enumeration='Xrt3dAlign'
	enumeration='Xrt3dAnchor'
	enumeration='Xrt3dAnnoMethod'
	enumeration='Xrt3dBarFormat'
	enumeration='Xrt3dBorder'
	enumeration='Xrt3dDistnMethod'
	enumeration='Xrt3dLegendStyle'
	enumeration='Xrt3dStrokeFont'
	enumeration='Xrt3dType'
	enumeration='Xrt3dZoneMethod'
	enumeration='XrtAdjust'
	enumeration='XrtAlign'
	enumeration='XrtAnchor'
	enumeration='XrtAnnoMethod'
	enumeration='XrtAnnoPlacement'
	enumeration='XrtBorder'
	enumeration='XrtFldCase'
	enumeration='XrtFldDispScrollBar'
	enumeration='XrtFldError'
	enumeration='XrtFldFieldType'
	enumeration='XrtFldFormat'
	enumeration='XrtFldMatchMask'
	enumeration='XrtFldNegFormat'
	enumeration='XrtFldRange'
	enumeration='XrtLblBorderType'
	enumeration='XrtLblRotation'
	enumeration='XrtNumMethod'
	enumeration='XrtOriginPlacement'
	enumeration='XrtPieOrder'
	enumeration='XrtPieThresholdMethod'
	enumeration='XrtRotate'
	enumeration='XrtSpinArrowLayout'
	enumeration='XrtSpinType'
	enumeration='XrtTblAlignment'
	enumeration='XrtTblAttachment'
	enumeration='XrtTblBorderSide'
	enumeration='XrtTblBorderType'
	enumeration='XrtTblCase'
	enumeration='XrtTblColumnPlacement'
	enumeration='XrtTblDataType'
	enumeration='XrtTblDispScrollBar'
	enumeration='XrtTblDoubleBuffer'
	enumeration='XrtTblJumpScroll'
	enumeration='XrtTblLocation'
	enumeration='XrtTblMode'
	enumeration='XrtTblOverflow'
	enumeration='XrtTblPixmapLayout'
	enumeration='XrtTblRepaint'
	enumeration='XrtTblResize'
	enumeration='XrtTblRowPlacement'
	enumeration='XrtTblSBPosition'
	enumeration='XrtTblSelectionPolicy'
	enumeration='XrtTblValidatePolicy'
	enumeration='XrtTblXmStringGetMode'
	enumeration='XrtTblXmStringSetMode'
	enumeration='XrtTimeUnit'
	enumeration='XrtType'
	cheader='Xm/Xrt3d.h'
	cheader='Xm/XrtGraph.h'
	cheader='Xm/XrtTable.h'
	cheader='Xm/XrtLabel.h'
	cheader='Xm/XrtField.h'
	alias='XmRxrtFldDecimalPlaces'
	alias='XmRxrtFldInt'
	alias='XmRxrtFldPixel'
	alias='XtRXrtString'
	converter='XmRPixmap'
	converter='XmRStringTable'
	converter='XmRxrtFldDate'
	converter='XmRxrtFldDateIncrement'
	converter='XmRxrtFldDateList'
	converter='XmRxrtFldFloat'
	converter='XmRxrtFldFloatList'
	converter='XmRxrtFldIntList'
	converter='XmRxrtLblPixmap'
	converter='XmRxrtTblAlignmentSeries'
	converter='XmRxrtTblBooleanSeries'
	converter='XmRxrtTblBorderSidesSeries'
	converter='XmRxrtTblBorderTypeSeries'
	converter='XmRxrtTblCaseSeries'
	converter='XmRxrtTblCellSize'
	converter='XmRxrtTblCellSizeSeries'
	converter='XmRxrtTblCellValues'
	converter='XmRxrtTblClipPixmapSeries'
	converter='XmRxrtTblColorSeries'
	converter='XmRxrtTblContext'
	converter='XmRxrtTblDataTypeSeries'
	converter='XmRxrtTblDoubleBuffer'
	converter='XmRxrtTblFontListSeries'
	converter='XmRxrtTblInt'
	converter='XmRxrtTblIntSeries'
	converter='XmRxrtTblMode'
	converter='XmRxrtTblOverflowSeries'
	converter='XmRxrtTblPSFontMapList'
	converter='XmRxrtTblPixmapLayoutSeries'
	converter='XmRxrtTblPixmapSeries'
	converter='XmRxrtTblRange'
	converter='XmRxrtTblRangeList'
	converter='XmRxrtTblRepaint'
	converter='XmRxrtTblStringSeries'
	converter='XmRxrtTblWidget'
	converter='XmRxrtTblWidgetSeries'
	converter='XmRxrtTblWidgetShadowSeries'
	converter='XmRxrtTblXmStringGetMode'
	converter='XmRxrtTblXmStringList'
	converter='XmRxrtTblXmStringSetMode'
	converter='XtRCursor'
	converter='XtRFont'
	converter='XtRXrt3dContourStyles'
	converter='XtRXrt3dData'
	converter='XtRXrt3dDistnTable'
	converter='XtRXrt3dDouble'
	converter='XtRXrt3dGridLines'
	converter='XtRXrt3dProject'
	converter='XtRXrt3dStrings'
	converter='XtRXrt3dTextList'
	converter='XtRXrt3dValueLabels'
	converter='XtRXrt3dXYColors'
	converter='XtRXrtData'
	converter='XtRXrtDataStyle'
	converter='XtRXrtDataStyles'
	converter='XtRXrtStrings'
	converter='XtRXrtValueLabels'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
	page='Axis'
	page='Bar'
	page='DataSettings'
	page='DataStyles'
	page='DrawOpts'
	page='Footer'
	page='Graph'
	page='Header'
	page='Labels'
	page='Legend'
	page='Marker'
	page='Pie'
	page='X_Axis1'
	page='X_Axis2'
	page='XAxis'
	page='Y_Axis1'
	page='Y_Axis2'
	page='Y2_Axis1'
	page='Y2_Axis2'
	page='YAxis'
	page='ZAxis'
	page='Row/Col Options'
	page='Widgets'
	page='Constraint'
	page='Cursor'
	page='Scroll Bars'
	page='Label'
	page='Contours'
	page='TextAttach'
	page='readonly'
	page='values'
}
family 'XRT/table' {
	widget='xtXrtTableWidgetClass'
	widget='xtXrtLabelWidgetClass'
	enumeration='Alignment'
	enumeration='LabelType'
	enumeration='StringDirection'
	enumeration='XrtLblBorderType'
	enumeration='XrtLblRotation'
	enumeration='XrtTblAlignment'
	enumeration='XrtTblAttachment'
	enumeration='XrtTblBorderSide'
	enumeration='XrtTblBorderType'
	enumeration='XrtTblCase'
	enumeration='XrtTblColumnPlacement'
	enumeration='XrtTblDataType'
	enumeration='XrtTblDispScrollBar'
	enumeration='XrtTblDoubleBuffer'
	enumeration='XrtTblJumpScroll'
	enumeration='XrtTblLocation'
	enumeration='XrtTblMode'
	enumeration='XrtTblOverflow'
	enumeration='XrtTblPixmapLayout'
	enumeration='XrtTblRepaint'
	enumeration='XrtTblResize'
	enumeration='XrtTblRowPlacement'
	enumeration='XrtTblSBPosition'
	enumeration='XrtTblSelectionPolicy'
	enumeration='XrtTblValidatePolicy'
	enumeration='XrtTblXmStringGetMode'
	enumeration='XrtTblXmStringSetMode'
	header='Xm/XrtTable.h'
	header='Xm/XrtLabel.h'
	cheader='Xm/XrtTable.h'
	cheader='Xm/XrtLabel.h'
	converter='XmRPixmap'
	converter='XmRStringTable'
	converter='XmRxrtLblPixmap'
	converter='XmRxrtTblAlignmentSeries'
	converter='XmRxrtTblBooleanSeries'
	converter='XmRxrtTblBorderSidesSeries'
	converter='XmRxrtTblBorderTypeSeries'
	converter='XmRxrtTblCaseSeries'
	converter='XmRxrtTblCellSize'
	converter='XmRxrtTblCellSizeSeries'
	converter='XmRxrtTblCellValues'
	converter='XmRxrtTblClipPixmapSeries'
	converter='XmRxrtTblColorSeries'
	converter='XmRxrtTblContext'
	converter='XmRxrtTblDataTypeSeries'
	converter='XmRxrtTblDoubleBuffer'
	converter='XmRxrtTblFontListSeries'
	converter='XmRxrtTblInt'
	converter='XmRxrtTblIntSeries'
	converter='XmRxrtTblMode'
	converter='XmRxrtTblOverflowSeries'
	converter='XmRxrtTblPSFontMapList'
	converter='XmRxrtTblPixmapLayoutSeries'
	converter='XmRxrtTblPixmapSeries'
	converter='XmRxrtTblRange'
	converter='XmRxrtTblRangeList'
	converter='XmRxrtTblRepaint'
	converter='XmRxrtTblStringSeries'
	converter='XmRxrtTblWidget'
	converter='XmRxrtTblWidgetSeries'
	converter='XmRxrtTblWidgetShadowSeries'
	converter='XmRxrtTblXmStringGetMode'
	converter='XmRxrtTblXmStringList'
	converter='XmRxrtTblXmStringSetMode'
	converter='XtRCursor'
	converter='XtRFont'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
	page='Row/Col Options'
	page='Widgets'
	page='Text Contexts'
	page='Text Series'
	page='Other Contexts'
	page='Other Series'
	page='Constraint'
	page='Cursor'
	page='Scroll Bars'
	page='Label'
	page='new'
	page='new1'
	page='Table wide'
	page='Child Widget'
	page='Cell/Label Context'
	page='Cell-only Series'
	page='Cell/Label Series'
	page='Cell-only Context'
	page='Label-only '
	page='Other'
	page='Table wide 2'
	page='Table wide 3'
}
family 'XRT/3d' {
	widget='xtXrt3dWidgetClass'
	enumeration='Xrt3dAdjust'
	enumeration='Xrt3dAlign'
	enumeration='Xrt3dAnchor'
	enumeration='Xrt3dAnnoMethod'
	enumeration='Xrt3dBarFormat'
	enumeration='Xrt3dBorder'
	enumeration='Xrt3dDistnMethod'
	enumeration='Xrt3dLegendStyle'
	enumeration='Xrt3dStrokeFont'
	enumeration='Xrt3dType'
	enumeration='Xrt3dZoneMethod'
	cheader='Xm/Xrt3d.h'
	converter='XtRFont'
	converter='XtRXrt3dContourStyles'
	converter='XtRXrt3dData'
	converter='XtRXrt3dDistnTable'
	converter='XtRXrt3dDouble'
	converter='XtRXrt3dGridLines'
	converter='XtRXrt3dProject'
	converter='XtRXrt3dStrings'
	converter='XtRXrt3dTextList'
	converter='XtRXrt3dValueLabels'
	converter='XtRXrt3dXYColors'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
	page='Axis'
	page='Bar'
	page='DataSettings'
	page='Footer'
	page='Graph'
	page='Header'
	page='Legend'
	page='XAxis'
	page='YAxis'
	page='ZAxis'
	page='Contours'
	page='TextAttach'
}
family 'XRT/graph' {
	widget='xtXrtGraphWidgetClass'
	enumeration='XrtAdjust'
	enumeration='XrtAlign'
	enumeration='XrtAnchor'
	enumeration='XrtAnnoMethod'
	enumeration='XrtAnnoPlacement'
	enumeration='XrtBorder'
	enumeration='XrtNumMethod'
	enumeration='XrtOriginPlacement'
	enumeration='XrtPieOrder'
	enumeration='XrtPieThresholdMethod'
	enumeration='XrtRotate'
	enumeration='XrtTimeUnit'
	enumeration='XrtType'
	cheader='Xm/XrtGraph.h'
	alias='XtRXrtString'
	converter='XtRFont'
	converter='XtRXrtData'
	converter='XtRXrtDataStyle'
	converter='XtRXrtDataStyles'
	converter='XtRXrtStrings'
	converter='XtRXrtValueLabels'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
	page='Axis'
	page='Bar'
	page='DataStyles'
	page='DrawOpts'
	page='Footer'
	page='Graph'
	page='Header'
	page='Labels'
	page='Legend'
	page='Marker'
	page='Pie'
	page='X_Axis1'
	page='X_Axis2'
	page='Y_Axis1'
	page='Y_Axis2'
	page='Y2_Axis1'
	page='Y2_Axis2'
}
family 'XRT/field' {
	widget='xmXrtFieldWidgetClass'
	widget='xmXrtStringFieldWidgetClass'
	widget='xmXrtDateFieldWidgetClass'
	widget='xmXrtFloatFieldWidgetClass'
	widget='xmXrtCurrencyFieldWidgetClass'
	widget='xmXrtIntFieldWidgetClass'
	widget='xmXrtComboBoxWidgetClass'
	widget='xmXrtSpinBoxWidgetClass'
	enumeration='Orientation'
	enumeration='XrtFldCase'
	enumeration='XrtFldDispScrollBar'
	enumeration='XrtFldError'
	enumeration='XrtFldFieldType'
	enumeration='XrtFldFormat'
	enumeration='XrtFldMatchMask'
	enumeration='XrtFldNegFormat'
	enumeration='XrtFldRange'
	enumeration='XrtSpinArrowLayout'
	enumeration='XrtSpinType'
	cheader='Xm/XrtField.h'
	alias='XmRxrtFldDecimalPlaces'
	alias='XmRxrtFldInt'
	alias='XmRxrtFldPixel'
	converter='XmRxrtFldDate'
	converter='XmRxrtFldDateIncrement'
	converter='XmRxrtFldDateList'
	converter='XmRxrtFldFloat'
	converter='XmRxrtFldFloatList'
	converter='XmRxrtFldIntList'
	popup='xd_colour_dialog_create'
	popup='xd_font_dialog_create'
	popup='xd_fsb_dialog_create'
	popup='xd_pixmap_dialog_create'
	popup='xd_string_dialog_create'
	page='display'
	page='margins'
	page='settings'
	page='callbacks'
	page='misc'
	page='readonly'
	page='values'
}
