.TH chkclassproto N "09 Mar 1994"
.SH NAME
chkclassproto \- verify a chkclasses proto area.
.SH SYNOPSIS
chkclassproto
.BI \-c chkproto
.BI \-p pkgdir
.BI \-a arch
[
.B \-vm
]
.SH DESCRIPTION
.B chkclassproto
verifies if a directory tree to be used either as a base or compare tree
for
.B chkclasses
is populated with all the necessary files.
A list of files in the editable classes is built from the package definition
tree and architecture specified with the
.B "-p"
and
.B "-a"
options.
The files in that list are checked to see if they exist and are readable.
Optionally,
.B chkclassproto
will verify the existence and readability of .mod files.
.SH OPTIONS
.TP 10
.BI \-c chkproto
Root directory of the proto area to be checked.
.TP 10
.BI \-p pkgdir
Root directory of the package definition tree.
.TP 10
.BI \-a arch
Specify the architecture.  Different platforms of the same architecture are
translated to the base architecture.  Thus sun4, sun4c, sun4m, etc. are
translated to sparc.
.TP 10
.B \-v
Verbose.  Include class and package names in error messages.
translated to sparc.
.TP 10
.B \-m
Check for .mod files.
.SH SEE ALSO
.LP
chkclasses(N), mkclassproto(N), syncprotos(N)
